  @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


	echo =============================================================
	echo %date% %time% - %~dpnx0 [%*]
:CHECKHELP
	set bat_vers=0.974

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	set bat_camerahint=+
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG

	set bat_color_on=toggle on
	set bat_calnstars=80
	set bat_caloc=2.50

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_logfile=!bat_startlocation!\AutoCams.bat.log
	
	set bat_autonomous=
	echo.%*|find /i "autonomous">nul:
	if %errorlevel% equ 0 (
		set bat_autonomous=autonomous
		set bat_precapturedfilesdir=%~1
		set bat_capturedfilesdir=%~1
		set bat_archivedfilesdir=%~2
		set bat_camera=%~3
	)
	
	%bat_echolog% =============================================================
	%bat_echolog% %date% %time% - %~dpnx0 %*
	
	set bat_returncode=0

	set bat_hasrun_post=false
	set bat_hasrun_reprocess=false
	set bat_hasrun_calupdate=false
	set bat_hasrun_cal=false
	set bat_hasrun_confirm=false
	set bat_hasrun_submission=false
	set bat_hasrun_zip=false

	call :READCONFIG
	call :GETCONFIRMEDCOUNT

	call :PARSEARGS %*

	if not exist "!bat_mainspec!\!bat_getdirname!" (
		echo     ERROR: specified source dir doesn't exist:^("!bat_mainspec!\!bat_getdirname!"^)
		exit /b 1
	) else (
		echo     bat_mainspec=!bat_mainspec!
	)
	
	if defined bat_autonomous (
		call :AUTOCAMS
		call :SAVECONFIG
		echo.
		echo Done with %0 %*
		echo.
		EXIT
	)
	
goto :MENU

	
:PARSEARGS
!bat_echolog! call :PARSEARGS %*
!bat_echolog! '     :PARSEARGS %1, %~dp1, %~nx1
	if defined bat_autonomous (
		set bat_getdirname=%~nx2
		set bat_arg1=%~2
	) else (
		set bat_getdirname=%~nx1
		set bat_arg1=%~1
	)
	set bat_mainspec=!bat_startlocation!\ArchivedFiles
	set bat_mainfilter=^|find /i "!bat_getdirname!"
	
	if "!bat_arg1!" neq "" (
		if ":" equ "!bat_arg1:~1,1!" (
			echo     Format: x:\CAMS\ArchivedFiles\date/time
			rem format is: x:\CAMS\ArchivedFiles\2011_08_15_00_00_00
			rem set bat_startdrive=!bat_arg1:~0,2!
			rem set bat_startlocation=!bat_startdrive!\CAMS
			set bat_mainspec=!bat_startlocation!\ArchivedFiles
			set bat_mainfilter=^|find /i "!bat_getdirname!"
		) else (
			rem look for 2011_08_15_00_00_00
			echo     Scanning like this: %~1^|find /i /c "ArchivedFiles\"
			echo     %~1|find /i /c "ArchivedFiles\"
			echo     !errorlevel!
			if !errorlevel! equ 0 (
				echo     Format: ArchivedFiles\!bat_getdirname!
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=^|find /i "!bat_getdirname!"
			) else (
				echo     Format: 2011_08_15_00_00_00
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=|find /i /c "!bat_getdirname!"
			)
		)
	)
!bat_echolog! return-:PARSEARGS [!bat_getdirname!, !bat_mainspec!, !bat_mainfilter!]
%return%



REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================
REM ======================= MAIN MENU ===================================

:MENU
	call :CLEARSCREEN
	color !bat_color!
	if not defined bat_captureddate (
		set bat_titlebar=%~dpnx0 - CAMS MENU Vers !bat_vers!
	) else (
		set bat_titlebar=%~dpnx0 - CAMS MENU Vers !bat_vers!  for Captured Date: !bat_captureddate!
		call :FORMATDATE bat_dateinput !bat_captureddate!
	)
	rem TITLE !bat_titlebar!
	TITLE %~dpnx0 - CAMS MENU
	echo  !bat_titlebar!
	echo.
	echo  1. Choose target location     !bat_targetlocation!
	echo  2. Enter Camera               !bat_camera!
	echo  3. Enter Captured Date        !bat_captureddate!
	echo.
	echo  4. Choose CapturedFiles       "!bat_capturedfilesdir!"  [Files=!bat_capturedcount!]
	echo  5.   Check Skipped Frames
	echo.
	echo  6. Choose ArchivedFiles       "!bat_archivedfilesdir!"  [F/M=!bat_archivedcount!/!bat_archivedmeteorcount!]
	echo  7. FTP_MeteorCal_Update       
	echo  7b.  FTP_MeteorCal_AutoUpdate
	echo  7c.  FTP_MeteorCal_AutoUpdate w/ prompt
	echo  8.   FTP_MeteorCal             
	echo  9. Apply Cal to Archived      Current Cal: !bat_latestcal!
	echo 10. FTP_Confirmation           "!bat_confirmedfilesdir!" [Meteor Count: !bat_confirmedmeteorcount!]
	echo 11.   Edit comments.txt file   
	echo 12.   Apply Cal to Confirmed   Confirmed Cal: !bat_confirmedcal!
	echo 13. Submission
	echo 14.   Choose Submission dir    "!bat_submissionfilesdir!"
	echo 15.   Undo from Submission 
	echo 16. Make Transmit Zip         !bat_zipfile!
	echo 17. Upload Zip via FTP
	echo 18. Email notice
	echo.
	echo  A. Autonomous mode
	echo  R. Reset
	echo  U. Utility Menu
	echo  Q. Quit
	
	echo.
	
	set bat_choice=none
	set /P bat_choice=Enter choice: 
	echo.
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" equ "r" (
		CALL :RESET
	)
	if /i "!bat_choice!" equ "u" goto :UTILSMENU
	
	if /i "!bat_choice!" equ "1"  call :CHOOSETARGETDRIVE&goto :MENU
	if /i "!bat_choice!" equ "2"  call :CHOOSECAMERA&goto :MENU
	if /i "!bat_choice!" equ "3"  call :CHOOSEDATE&goto :MENU
	
	if /i "!bat_choice!" equ "4"  call :CHOOSECAP&goto :MENU
	if /i "!bat_choice!" equ "5"  call :SKIPPEDFRAMES&GOTO :MENU
	
	if /i "!bat_choice!" equ "6"  call :CHOOSEARCH&goto :MENU
	if /i "!bat_choice!" equ "7"  call :CALUPDATE&goto :MENU
	if /i "!bat_choice!" equ "7b"  call :CALUPDATEAUTO&goto :MENU
	if /i "!bat_choice!" equ "7c"  call :CALUPDATEAUTOPROMPT&goto :MENU
	if /i "!bat_choice!" equ "8"  call :CAL&goto :MENU
	if /i "!bat_choice!" equ "9"  call :APPLY&goto :MENU
	if /i "!bat_choice!" equ "10" call :CONFIRM&goto :MENU
	if /i "!bat_choice!" equ "11" call :EDITCOMMENTS&goto :MENU
	if /i "!bat_choice!" equ "12" call :APPLYCONFIRMED&goto :MENU
	if /i "!bat_choice!" equ "13" call :SUBMIT&goto :MENU
	if /i "!bat_choice!" equ "14" call :choosesubmission&goto :MENU
	if /i "!bat_choice!" equ "15" call :RESTORESUBMIT&goto :MENU
	if /i "!bat_choice!" equ "16" call :MAKEZIP&goto :MENU
	if /i "!bat_choice!" equ "17" call :UPLOADFTP&goto :MENU
	if /i "!bat_choice!" equ "18" call :EMAILTEXT&goto :MENU
	
	rem Hidden extras
	if /i "!bat_choice!" equ "v"  call :VARIABLES&goto :MENU
	if /i "!bat_choice!" equ "a"  call :AUTO&goto :MENU
	if /i "!bat_choice!" equ "cls" cls&:goto :MENU
	
	if /i "!bat_choice!" equ "1u" call :CMDPROMPT&goto :MENU
	if /i "!bat_choice!" equ "2u" call :CHECKBINFILESIZE&goto :MENU
	if /i "!bat_choice!" equ "3u" call :CHECKBINCLEANUP&goto :MENU
	if /i "!bat_choice!" equ "4u" call :CHECKFREESPACE&goto :MENU
	if /i "!bat_choice!" equ "5u" call :LISTDRIVES&goto :MENU
	if /i "!bat_choice!" equ "6u" call :VALIDATECAL&goto :MENU
	if /i "!bat_choice!" equ "7u" call :METEORCOUNTPRE&goto :MENU
	if /i "!bat_choice!" equ "7bu"  call :CALUPDATEAUTO&goto :MENU
	if /i "!bat_choice!" equ "8u" call :METEORCOUNTSUB&goto :MENU
	if /i "!bat_choice!" equ "9u" call :GETFFDIRLIST&goto :MENU
	if /i "!bat_choice!" equ "10u" call :GETCAPTURED&goto :MENU
	if /i "!bat_choice!" equ "11u" call :GETARCHIVED&goto :MENU
	if /i "!bat_choice!" equ "12u" call :GETTWILIGHT&GOTO :MENU
	if /i "!bat_choice!" equ "13u" call :LAUNCHCAPTURE&GOTO :MENU
	if /i "!bat_choice!" equ "14u"  call :REPROCESSMULTI&goto :MENU
	if /i "!bat_choice!" equ "15u" call :POSTMULTI "!bat_captureddate!"&goto :MENU
	if /i "!bat_choice!" equ "16u" call :MERGECASE&goto :MENU
	if /i "!bat_choice!" equ "17u" call :DAYOFWEEK&goto :MENU
	if /i "!bat_choice!" equ "18u" call :SAVECONFIG&goto :MENU
	if /i "!bat_choice!" equ "19u" call :NIGHTMODE&goto :MENU
	if /i "!bat_choice!" equ "?" set bat_&pause&goto :MENU
	
goto :MENU




	rem R. Reset ******************************************
:RESET
	set bat_captureddate=
	set bat_capturedfilesdir=
	set bat_capturedcount=
	set bat_archivedfilesdir=
	set bat_archivedcount=
	set bat_archdirname=
	set bat_archivedate=
	set bat_archivedcount=
	set bat_archivedmeteorcount=
	set bat_confirmedfilesdir=
	set bat_confirmedmeteorcount=
	set bat_submissionfilesdir=
	set bat_submissiondirname=
	set bat_submissiondate=
	call :SAVECONFIG
%bat_return%




	rem a. AutoCams  ***************************
:AUTO
!bat_echolog! call :AUTO %*
	!bat_echolog! '    start "autocams" autocams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
					   start "autocams" autocams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
!bat_echolog! return-:AUTO [!bat_capturedfilesdir!]
%bat_return%


:AUTOCAMS
echo call :AUTOCAMS %*
	rem This routine performs the following steps:

:AZ_FIXDETECTPATHS
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!"

:AZ_CALAUTO
	rem   7b. FTP_MeteorCal_AutoUpdate
	call :CALUPDATEAUTO
	if "!bat_returncode!" neq "0" goto :AUTOCAMS_END

:AZ_APPLYAUTO
	rem   9.  FTP_ApplyCal2detectinfo
	call :APPLYAUTO
	if !bat_returncode! neq 0 goto :AUTOCAMS_END

:AC_SUBMITAUTO
	rem  13.  Submission
	call :SUBMITAUTO

:AC_MAKEZIPAUTO
	rem  16.  Make Transmit Zip
	call :MAKEZIPAUTO
goto :AUTOCAMS_END
:AC_FTPAUTO
	rem  17.  Upload Zip
	call :UPLOADFTPAUTO

:AUTOCAMS_END
echo return-:AUTOCAMS %*
%bat_return%



	rem 1. Choose Target Drive  ***************************
:CHOOSETARGETDRIVE
	call ListDrives.bat
	echo.
	echo.
	echo Idealy, the target location is specified as a Drive:
	echo There are cases where the target location is a drive and path
	echo instead.  In that case, enter the Drive and Path without including
	echo the CAMS part.
	echo.
	set bat_choice=
	set /P bat_choice=Enter drive [!bat_targetdrive!]: 
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_targetdrive!)
	set bat_choice=!bat_choice!\\
	set bat_choice=!bat_choice:\\\=!
	set bat_choice=!bat_choice:\\=!
	
		rem Convert "C:\CAMS" to "C:"
	if /i "!bat_choice:~-5!" equ "\CAMS" (
		set bat_choice=!bat_choice:~-5!
	)

	if /i "!bat_choice:~0,2!\CAMS" neq "!bat_exedir!" (
		echo dir "!bat_choice!\CAMS\AutoCams.bat" /b
		     dir "!bat_choice!\CAMS\AutoCams.bat" /b
		if exist "!bat_choice!\CAMS\AutoCams.bat" (
			cd /d "!bat_choice!"
			call :RESET
			set bat_targetdrive=!bat_choice!
			set bat_targetlocation=!bat_choice!
			call :SAVECONFIG
			!bat_echolog! '    "!bat_choice!\CAMS\AutoCams.bat"
			                   "!bat_choice!\CAMS\AutoCams.bat"
		) else (
			echo     ERROR - The cams executables and scripts are not found
			echo             in the new location. You will need to copy them
			echo             to the new location before being able to switch to:
			echo             "!bat_choice!"
		)
	) else (
		call :RESET
		set bat_targetdrive=!bat_choice!
		set bat_targetlocation=!bat_choice!

		call :SAVECONFIG
	)
%bat_return%
	


	rem obsolete subroutine
:ENTERCAMERA
	set /p bat_camera=Enter Camera number: 
	call :SAVECONFIG

%bat_return%



	rem 2. Enter Camera ***********************************
:CHOOSECAMERA
	if not exist "!bat_targetlocation!\CAMS\Cal\CameraSites.txt" (
		echo ERROR - Not Found: "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
		echo.
	)
	set bat_choice=
	set /P bat_choice=Enter your camera number: 
	if "!bat_choice!" equ "" goto :CAMERA_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_camera!)
	
	set bat_temp=!bat_choice!      
	set bat_temp=!bat_temp:~0,6!
	
	find /i "!bat_temp!!bat_camerahint!" "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
	if !errorlevel! neq 0 (
		echo ERROR - Camera Not Found: !bat_choice! in "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"
		echo.
		pause
		goto :CAMERA_END
	)

	set bat_choice2=
	echo.
	set /P bat_choice2=Do you see your camera in this list? Y/N 
	if /i "!bat_choice2!" neq "y" goto :CAMERA_END

	set bat_camera=!bat_choice!
	call :SAVECONFIG

:CAMERA_END
%bat_return%


	rem Not yet implemented ***************************************
:CHOOSESTATION
	set bat_temp= 
	set /a bat_counter=0
	for /f "usebackq tokens=1-7 skip=2" %%a in (`type "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"^|sort /+63`) do (
		if /i "%%a" equ "Cam#" goto :CHOOSESTATION2
		if /i "%%a" equ "----" goto :CHOOSESTATION2
		if /i "%%f" equ "!bat_temp!" goto :CHOOSESTATION2
		if "!bat_temp!" neq "!bat_siteabbrev!" (
			set bat_counter+=1
			set bat_siteabbrev=%%f
			set bat_temp=!bat_siteabbrev!
			echo %%f  %%g
		)
		
:CHOOSESTATION2		
	)
	
	set bat_choice=
	set /P bat_choice=Enter your site abbreviation (2 characters): 
	
	set bat_temp= 
	set /a bat_counter=0
	for /f "usebackq tokens=1-7 skip=2" %%a in (`type "!bat_targetlocation!\CAMS\Cal\CameraSites.txt"^|sort /+63`) do (
		if /i "%%a" equ "Cam#" goto :CHOOSESTATION2
		if /i "%%a" equ "----" goto :CHOOSESTATION2
		if /i "%%f" equ "!bat_choice!" (
			set bat_counter+=1
			echo %%a  %%b  %%c  %%d  %%e  %%f  %%g
		)
	)
	
	set bat_choice=
	set /P bat_choice=Enter your camera number: 
	set bat_camera=!bat_choice!
%bat_return%



	rem 3. Enter Captured Date  ***********************************
:CHOOSEDATE
	echo.
	echo   Here is a list of CaptureFiles directories:
	echo.
	set bat_found=false
	set /a bat_counter=0
	set bat_usesubmissiondir=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					set bat_temp=%%~nxa
					set bat_temp=!bat_temp:~5,2!/!bat_temp:~8,2!/!bat_temp:~0,4!
					echo     !bat_counter!.  !bat_temp!   !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
				)
			)
		)
	)
	echo.
	set bat_choice=
	echo Enter the number matching the date to process or [S] to
	set /P bat_choice=list SubmissionFiles directories: 
	if /i "!bat_choice!" equ "" (
		echo     Aborting with "!bat_choice!"
		goto :CHOOSEDATE_END
	)
	
	rem ==================================
	if /i "!bat_choice!" NEQ "s" (
		echo.
		echo.!bat_choice!|find /i "/">nul:
		if !errorlevel! equ 0 (
			goto :CHOOSEDATE2
		)

		if !bat_counter! equ 0 (
			set bat_choice=
			set /P bat_choice=No CapturedFiles directories found matching "!bat_targetlocation!\CAMS\CapturedFiles". Press any key to skip. 
			goto :CHOOSEDATE_END
		)

		
		echo Listing of CapturedFiles: 
		set bat_found=false
		set /a bat_counter=0
		for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles" /b /ad /on`) do (
			set /a bat_counter+=1
			if "!bat_counter!" equ "!bat_choice!" (
				call :RESET
				set bat_found=true
				set bat_captureddate=%%a
				set bat_captureddate=!bat_captureddate:~0,10!
			)
		)
		if /i "!bat_found!" equ "false" goto :CHOOSEDATE_END
		
		goto :CHOOSEDATE3
	) else (
		if /i "!bat_choice!" equ "s" (
			echo     Scanning SubmissionFiles directory...
			set bat_usesubmissiondir=!bat_targetlocation!\CAMS\SubmissionFiles"

			set /a bat_counter=0
			echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`^) do ...
			for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`) do (
				set /a bat_counter+=1
				echo !bat_counter!. %%a
			)

			echo.
			if !bat_counter! equ 0 (
				set bat_choice=
				set /P bat_choice=No SubmissionFiles directories found matching !bat_captureddate!. Press any key to skip. 
				goto :CHOOSEDATE_END
			)

			set bat_choice=
			set /P bat_choice=Select the SubmissionFiles directory to work with: 
			if "!bat_choice!" equ "" goto :CHOOSEDATE_END

			set /a bat_counter=0
			set bat_found=false
			echo Listing of SubmissionFiles: 
			for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on`) do (
				set /a bat_counter+=1
				if "!bat_counter!" equ "!bat_choice!" (
					echo "!bat_choice!"
					call :RESET
					set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\%%a
					set bat_found=true
					set bat_dirname=%%~nxa
					set bat_submissiondirname=%%~nxa
					set bat_Submissiondate=!bat_dirname:~0,10!
					set bat_captureddate=!bat_Submissiondate!
				)
			)
			if "!bat_found!" neq "" (
				goto :CHOOSESUBMISSION1
			) else (
				goto :CHOOSEDATE_END
			)
		)& end if /i "!bat_choice!" equ "s"...
	)

:CHOOSEDATE2
	echo "!bat_choice!"
	call :RESET
	
	for /f "delims=/ tokens=1-3" %%a in ("!bat_choice!") do (
		set bat_yyyy=20%%c
		set bat_yyyy=!bat_yyyy:~-4!
		set bat_mm=0%%a
		set bat_mm=!bat_mm:~-2!
		set bat_dd=0%%b
		set bat_dd=!bat_dd:~-2!
	)

	set bat_captureddate=!bat_yyyy!_!bat_mm!_!bat_dd!
:CHOOSEDATE3
	set bat_capturedfilesdir=
	set bat_archivedfilesdir=
	set bat_latestcal=
	set /a bat_capturedcount=0
	set /a bat_archivedcount=0
	call :SAVECONFIG

	call :CHOOSECAP
	call :CHOOSEARCH
:CHOOSEDATE_END
%bat_return%


:CLEARSCREEN
	for /l %%A in (1,1,50) do (echo.)
%bat_return%



	rem 4. Choose CapturedFiles directory *******************
:CHOOSECAP
	rem Choose Captured directory
	echo.
	set /a bat_counter=0

	set bat_finddate=
	if "!bat_captureddate!" neq "" (
		set bat_finddate=\!bat_captureddate!*
	)

	echo    Listing of CapturedFiles:
	echo.
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`^) do ^(
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					echo      !bat_counter!. !bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
					set bat_tempfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
					set bat_tempdirname=%%~nxa
				)
			)
		)
	)
	echo.
	
	if !bat_counter! equ 0 (
		set /P bat_choice=No CapturedFiles directories found matching !bat_captureddate!
		goto :CHOOSECAP_END
	)
	
	
	if !bat_counter! equ 1 (
		set bat_capturedfilesdir=!bat_tempfilesdir!
		set bat_dirname=!bat_tempdirname!
		set bat_capdirname=!bat_tempdirname!
		set bat_found=true
		echo.
		echo         Automatically selecting !bat_capturedfilesdir! because there is only one choice. 
		goto :CHOOSECAP2
	)

	set bat_choice=
	set /P bat_choice=Select the CapturedFiles directory to work with ^([CR] to skip this step^): 
	if "!bat_choice!" equ "" goto :CHOOSECAP_END

	set /a bat_capturedcount=0
	set /a bat_archivedcount=0
	set /a bat_counter=0
	set bat_found=false
	set bat_dirname= 

	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\CapturedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_capturedfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\%%~nxa
						set bat_dirname=%%~nxa
						set bat_capdirname=%%~nxa
						set bat_found=true
					)
				)
			)
		)
	)
	if /i !bat_found! equ false goto :CHOOSECAP

:CHOOSECAP2
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
	)
	
	rem set bat_captureddate=
	set bat_archivedfilesdir=
	set bat_archdirname=
	set bat_archivedate=
	set bat_submissiondirname=
	set bat_submissiondate=

	echo         Getting file count, please wait...
	rem call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"

	call :GETCAMERAFROMCAPTURED

	call :SAVECONFIG
:CHOOSECAP_END
%bat_return%



:GETCAMERAFROMCAPTURED
!bat_echolog! call :GETCAMERAFROMCAPTURED %*
	set /a bat_capturedcount=0
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_capturedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)

!bat_echolog! return-:GETCAMERAFROMCAPTURED [bat_camera=!bat_camera, bat_capturedcount=!bat_capturedcount!]
%bat_return%




:	rem 5. SkippedFrames ******************************************
:SKIPPEDFRAMES
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\skippedFrames.bat "!bat_capturedfilesdir!" /v
	     call !bat_exedir!\SkippedFrames.bat "!bat_capturedfilesdir!" /v

	cd /d !bat_exedir!
	
	pause
%bat_return%




	rem 6. Choose ArchivedFiles directory ***********************
:CHOOSEARCH
	rem Choose Archived Directory
	echo.
	set /a bat_counter=0

	set bat_finddate=

	if "!bat_captureddate!" neq "" (
		set bat_finddate=\!bat_captureddate!*
	)


	echo    Listing of ArchivedFiles:
	echo.
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\ArchivedFiles!bat_finddate!" /b /ad /on`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					echo      !bat_counter!. !bat_targetlocation!\CAMS\ArchivedFiles\%%~nxa
					set bat_tempfilesdir=!bat_targetlocation!\CAMS\ArchivedFiles\%%~nxa
					set bat_tempdirname=%%~nxa
				)
			)
		)
	)
	echo.

	if !bat_counter! equ 0 (
		set /P bat_choice=No ArchivedFiles directories found matching !bat_captureddate!
		goto :CHOOSESEARCH_END
	)

	if !bat_counter! equ 1 (
		set bat_archivedfilesdir=!bat_tempfilesdir!
		set bat_dirname=!bat_tempdirname!
		set bat_archdirname=!bat_tempdirname!
	    set bat_archiveddate=!bat_dirname:~0,10!
		set bat_found=true
		echo.
		echo         Automatically selecting !bat_archivedfilesdir! because there is only one choice
		goto :CHOOSEarch2
	)

	
	
	set bat_choice=
	set /P bat_choice=Select the ArchivedFiles directory to work with ^([CR] to skip this step^) : 
	if "!bat_choice!" equ "" goto :CHOOSESEARCH_END

	set /a bat_counter=0
	set bat_found=false
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\ArchivedFiles" /b /ad /on!bat_finddate!`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_archivedfilesdir=!bat_targetlocation!\CAMS\ArchivedFiles\%%a
						set bat_found=true
						set bat_dirname=%%~nxa
						set bat_archdirname=%%~nxa
						set bat_archiveddate=!bat_dirname:~0,10!
					)
				)
			)
		)
	)
	if /i !bat_found! equ false goto :CHOOSEARCH

:CHOOSEarch2
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
	)
	echo         Getting file count, please wait...
	rem call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"

	call :GETCAMERAFROMARCHIVED

	if not exist "!bat_archivedfilesdir!\FTPdetectinfo.txt" (
		if exist "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_archiveddate!.txt" (
			echo     move /y "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_archiveddate!.txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"
			         move /y "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_archiveddate!.txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"
		)
	)
	
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_archivedfilesdir!"
	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount
	call "!bat_exedir!\FixDetectPaths.bat" "!bat_confirmedfilesdir!"
	call :GETCONFIRMEDCOUNT
	call :SAVECONFIG

:CHOOSESEARCH_END
%bat_return%


:GETCAMERAFROMARCHIVED
	set /a bat_archivedcount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%


:GETMETEORCOUNTARCHIVED
!bat_echolog! call :GETMETEORCOUNTARCHIVED %*
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
           
		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			
			if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
				set bat_latestcal=
				set /a bat_archivedmeteorcount=0
				
				goto :GETMETEORCOUNTARCHIVED_END
			)
		)
	)

	set bat_latestcal=
	set /a bat_archivedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".bin" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_latestcal=%%a
	)
	
:GETMETEORCOUNTARCHIVED_END
!bat_echolog! return-:GETMETEORCOUNTARCHIVED [!bat_archivedmeteorcount!, !bat_latestcal!, !bat_archivedfilesdir!\!bat_detectfile!]
%bat_return%


	rem 7. Cal Update ********************************************
:CALUPDATE
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :CALUPDATE_END
	)
	
	echo.
	echo Typically, you would calibrate using the ArchivedFiles dir, however,
	echo there may be times when the Meteor Count is low and you'd need to 
	echo calibrate using the CapturedFiles dir.  
	echo.
	echo Instructions: When asked to "Navigate to FF Folder for Reprocessing", 
	echo navigate to either the "!bat_archivedfilesdir" or 
	echo "!bat_capturedfilesdir!" and click OK.  
	echo.
	echo Press "1" until the "Mean O-C" value is less than 1.00. Then look at the 
	echo "Number of calstars used".  If the number is less than 100, you can run 
	echo the FTP_MeteorCal_Update again with the same or later time until the 
	echo "Mean O-C" value is less than 1.00 with the "Number of calstars used" 
	echo greater than 99.  If that method fails, run FTP_MeteorCal to perform a
	echo manual calibration.  Then verify your manual calibration using 
	echo FTP_MeteorCal_Update using the Mean O-C and calstars targets.
	echo.
	echo Write down the date/time of the FF file used for calibration. The 
	echo best time to do this is just before hitting "c". 
	echo.
	set /P 
	echo.
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\FTP_MeteorCal_Update.exe "!bat_caldir!" "!bat_archivedfilesdir!"
	     call !bat_exedir!\FTP_MeteorCal_Update.exe "!bat_caldir!" "!bat_archivedfilesdir!"
	cd /d !bat_exedir!
	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	pause
	echo.
:CALUPDATE_END
%bat_return%




	rem 7b. Cal Auto Update ********************************************
:CALUPDATEAUTO
!bat_echolog! call :CALUPDATEAUTO %* [bat_archivedmeteorcount=!bat_archivedmeteorcount!]
	set bat_retval=failed
	if /i "!bat_submissionfilesdir!" neq "" (
		!bat_echolog!
		!bat_echolog! '    You probably don't want to do this - you have already run Submission: 
		if not defined bat_autonomous (
			set /p bat_choice=[Enter] to quit, 
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=[!bat_returncode!]
			goto :CALUPDATEAUTO_END
		)
	)
	
	rem should be something like:
	rem   call :autocalupdate.bat 80 2.50 "!bat_caldir!" "!bat_capturedfilesdir!"
	rem
	rem and then check the autocal log for success/failure


	if /i "!bat_archivedmeteorcount!" equ "0" (
		!bat_echolog! '    ERROR - Meteor Count is 0. Nothing to calibrate.
		goto :CALUPDATEAUTO_END
	) else (
		!bat_echolog! '    call !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
					       call !bat_exedir!\FTP_MeteorCal_AutoUpdate.exe !bat_calnstars! !bat_caloc! "!bat_caldir!" "!bat_capturedfilesdir!"
		set bat_retval=executed
	)
	
	!bat_echolog!
	rem Validate the AutoCalUpdate.log file
	for /f "usebackq tokens=1-12" %%a in (`find /i "camera" "!bat_capturedfilesdir!\AutoCalUpdate.log"^|find /i "camera !bat_camera!"`) do (
		echo %%a,%%b,%%c,%%e,%%f,%%g,%%h,%%i
		set bat_autocal_camera=%%b
		set bat_autocal_success=%%c
		set bat_autocal_nstars=%%d
		set bat_autocal_oc=%%e
		set bat_autocal_fffile=%%f
		set bat_autocal_calfile=%%g
		
		if !bat_autocal_oc! GTR !bat_caloc! (
			set bat_autocal_success=1
			!bat_echolog!
			!bat_echolog! '    ERROR   O-C !bat_autocal_oc! GTR !bat_caloc!
			!bat_echolog!
			!bat_echolog! '    Camera:	!bat_autocal_camera!
			!bat_echolog! '    Success:	FAILED
			!bat_echolog! '    nStars:	!bat_autocal_nstars!
			!bat_echolog! '    O-C:	!bat_autocal_oc!
			!bat_echolog! '    FF file:	!bat_autocal_fffile!
			!bat_echolog! '    calfile:	!bat_autocal_calfile!
			!bat_echolog!

			if exist "!bat_caldir!\!bat_autocal_calfile!" (
				del "!bat_caldir!\!bat_autocal_calfile!"
			)
		)
	)
	
	if /i "!bat_autocal_success!" neq "0" (
		set bat_returncode=1
		!bat_echolog! '    set bat_returncode=[!bat_returncode!]
	) else (
		!bat_echolog!
		!bat_echolog! '    Camera:	!bat_autocal_camera!
		!bat_echolog! '    Success:	SUCCESS
		!bat_echolog! '    nStars:	!bat_autocal_nstars!
		!bat_echolog! '    O-C:		!bat_autocal_oc!
		!bat_echolog! '    FF file:	!bat_autocal_fffile!
		!bat_echolog! '    calfile:	!bat_autocal_calfile!
		!bat_echolog!
	)
	

:CALUPDATEAUTO_END
!bat_echolog! return-:CALUPDATEAUTO [!bat_retval!, !bat_returncode!]
%bat_return%


	rem 7c. Cal Auto Update with prompt ********************************************
:CALUPDATEAUTOPROMPT
!bat_echolog! call :CALUPDATEAUTOPROMPT %*

	set bat_retval=
	set bat_returncode=
	set bat_savedefaultnstars=!bat_calnstars!
	set bat_savedefaultoc=!bat_caloc!
:CALUPDATEAUTOPROMPT2
	
	set bat_choice=
	set /p bat_choice=Enter the minimum number of Cal Stars [!bat_calnstars!]: 
	if /i "!bat_choice!" equ "q" goto :CALUPDATEAUTOPROMPT_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_calnstars!)
	
	if /i !bat_choice! lss 30 (
		echo.
		echo     ERROR - Minimum number of Cal stars supported is 30 
		echo.
		goto :CALUPDATEAUTOPROMPT2
	)
	set /a bat_calnstars=!bat_choice!
	
	set bat_choice=
	set /p bat_choice=Enter the minimum Main )-C [!bat_caloc!]: 
	if /i "!bat_choice!" equ "q" goto :CALUPDATEAUTOPROMPT_END
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_caloc!)
	call :CALUPDATEAUTO
	set bat_calnstars=!bat_savedefaultnstars!
	set bat_caloc=!bat_savedefaultoc!

:CALUPDATEAUTOPROMPT_END
!bat_echolog! return-:CALUPDATEAUTOPROMPT [!bat_retval!, !bat_returncode!]
pause
%bat_return%





	rem 8. Manual Calibration ************************************
:CAL
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :CAL_END
	)

	rem bat_precalfile is the most recently created cal file in the directory
	set bat_precalfile=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_caldir!\CAL!bat_camera!*.txt" /b /a-d /od`) do (
		set bat_precalfile=!bat_caldir!\%%~a
	)
	
	rem Get the cal file from the current FTPdetectinfo.txt file
	for /f "usebackq tokens=* skip=2" %%a in (`find /i "CAL!bat_camera!_" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		set bat_detectcalfile=%%~a
	)
	
	echo.
	echo   Current Cal file used in "!bat_archivedfilesdir!\FTPdetectinfo.txt": 
	echo     !bat_detectcalfile!
	echo.
	
	set bat_retval1=
	set bat_retval2=
	echo   call "!bat_exedir!\ValidateCal.bat" /cal "!bat_detectcalfile!"
	       call "!bat_exedir!\ValidateCal.bat" /cal "!bat_detectcalfile!"
	echo   RA=!bat_retval1!, DEC=!bat_retval2!, time=!bat_retval3!
	echo.
	
	echo     You will be asked to navigate to the FF file to use for calibration
	echo     next. After that, you will be asked for the FOV, RA, and DEC of the 
	echo     new FF file. If you know the hhmmss segment of that file name, enter 
	echo     it now so we can estimate the new values to enter: 
	echo.
	set /p bat_choice=Enter the hhmmss value of the FF file [Enter to skip]: 

	if /i "!bat_choice!" equ "q" goto :CAL_END

	if /i "!bat_choice!" neq "" (
		echo     call :CALC_CAL_VALUES !bat_retval1! !bat_retval2! !bat_choice! !bat_retval3!
		         call :CALC_CAL_VALUES !bat_retval1! !bat_retval2! !bat_choice! !bat_retval3!
	)

	echo.
	echo     Considering the new FF file with a time segment value
	echo     of !bat_choice!, you will want to enter the following values:
	echo        RA  = !bat_ranew:~0,-4!.!bat_ranew:~-4!
	echo        DEC = !bat_retval2!
pause
rem goto :CAL_END

	cd /d !bat_targetlocation!\CAMS
	echo     call "!bat_exedir!\FTP_MeteorCal.exe" !bat_camera! "!bat_caldir!"
	         call "!bat_exedir!\FTP_MeteorCal.exe" !bat_camera! "!bat_caldir!"
	cd /d !bat_exedir!
	echo.
	
	!bat_echolog!
	
	set bat_manualcalfile=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_caldir!\CAL!bat_camera!*.txt" /b /a-d /od`) do (
		set bat_manualcalfile=!bat_caldir!\%%~a
	)
	
	if /i "!bat_precalfile!" neq "!bat_manualcalfile!" (
		echo   SUCCESS
		echo   Be sure to write down the date/time of the FF file used for calibration. 
		echo.
		 !bat_echolog! '    call "!bat_exedir!\ValidateCal.bat" /cal "!bat_manualcalfile!"
		 call "!bat_exedir!\ValidateCal.bat" /cal "!bat_manualcalfile!">>"!bat_logfile!"
		 call "!bat_exedir!\ValidateCal.bat" /cal "!bat_manualcalfile!"
		 
		call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount

	) else (
		!bat_echolog! '    The calibration failed - "!bat_precalfile!"
	)

	
	pause
	echo.

:CAL_END
!bat_echolog! return-:CAL [before:!bat_precalfile!, after:!bat_manualcalfile!]
%bat_return%



:CALC_CAL_VALUES
	set bat_calra=%~1
	set bat_caldec=%~2
	set bat_choice=%~3
	set bat_time=%~4

	rem calculate the entered time in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~0,2! bat_hh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~2,2!00 bat_mm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_choice:~4,2!00 bat_ss

	echo set /a "bat_hour=((!bat_ss! / 60) + !bat_mm!) / 60) + !bat_hh!00"
		 set /a "bat_mmdecimal=((!bat_ss! / 60) + !bat_mm!) / 60"
	set /a bat_hour=!bat_hh!00 + !bat_mmdecimal!
	set bat_hourdisplay=!bat_hh!.!bat_mmdecimal!


	rem calculate the old cal file time in hours
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~0,2! bat_timehh
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~3,2!00 bat_timemm
	call "!bat_exedir!\STRIPZEROS.bat" !bat_time:~6,2!00 bat_timess

	set /a "bat_timemmdecimal=((!bat_timess! / 60) + !bat_timemm!) / 60"
	set /a bat_timetotal=!bat_timehh!00+!bat_timemmdecimal!
	set bat_timemmdecimal=!bat_timemmdecimal!0000
	set bat_timemmdecimal=!bat_timemmdecimal:~0,4!
	set bat_timetotal=!bat_timehh!!bat_timemmdecimal!

	set /a bat_timediff=!bat_hour!00 - !bat_timetotal!
	set /a bat_diffdegrees=!bat_timediff! * 15


	rem Caluclate the new RA value based on the difference in hours
	set bat_temp2=
	call "!bat_exedir!\STRIPZEROS.bat" !bat_calra! bat_calra
	for /f "usebackq tokens=1,2 delims=." %%a in ('!bat_calra!') do (
		set bat_radeg=%%a
		set bat_radegdecimal=%%b

		set bat_temp2=!bat_radegdecimal!0000
		set bat_temp2=!bat_temp2:~0,4!
		set bat_ratotal=!bat_radeg!!bat_temp2!

		set /a bat_ranew=!bat_ratotal! + !bat_diffdegrees!
		if !bat_ranew! GEQ 3600000 (
			set /a bat_ranew=3600000 - !bat_ranew!
		)
	)

	echo.
	echo     Data from current calibration file: !bat_detectcalfile!
	echo        time=!bat_time!, !bat_timetotal!, !bat_timetotal:~0,-4!.!bat_timetotal:~-4!
	echo        RA  =!bat_retval1!, !bat_ratotal!
	echo        DEC =!bat_retval2!
	echo.
	rem echo     bat_timediff=!bat_timediff!
	rem echo     bat_diffdegrees=!bat_diffdegrees!
	rem echo.
	echo     Data from the FF file based on the entered time segment: !bat_choice!
	echo        time=!bat_hour:~0,-2!.!bat_hour:~-2!
	echo        RA  =!bat_ranew!
	echo        DEC =!bat_caldec!
	echo.

		
:CALC_CAL_VALUES_END
rem echo return-:CALC_CAL_VALUES [in=%*] [!bat_timetotal!, !bat_hour!, !bat_ranew!, !bat_diffdegrees!]
%bat_return%


	rem 9. Apply cal to detectinfo *******************************
:APPLY
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :APPLY_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :APPLY_END
	)
	
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	cd /d !bat_exedir!

	set bat_latestcal=
	echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`^) do...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestcal (
			set bat_latestcal=%%a
			echo.
			echo   Reading the current FTPdetectinfo.txt file and scanning for the cal
			echo   file now in use...
			echo      "!bat_latestcal!"
		)
	)


:APPLY_END
	pause
%bat_return%



	rem 9. Apply cal to detectinfo *******************************
:APPLYAUTO
!bat_echolog! call :APPLYAUTO %*
	set bat_retval=failed
	set bat_latestcal=

	if "!bat_archivedmeteorcount!" equ "0" (
		!bat_errorlog! '    ERROR - Meteor Count is 0. Nothing to calibrate.
	) else (
		cd /d !bat_targetlocation!\CAMS
		!bat_echolog! '     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!
						    call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!" !bat_autonomous!>nul:
		set bat_returncode=!errorlevel!
		!bat_echolog! '    ERRORLEVEL=[!bat_returncode!]
		if !bat_returncode! neq 0 (
			!bat_echolog! '    ERROR ApplyCal.bat failed
			goto :APPLYAUTO_END
		)
		cd /d !bat_exedir!

		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`^) do ...>>"!bat_logfile!"
		echo for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`^) do ...
		for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
			if not defined bat_latestcal (
				set bat_latestcal=%%a
			)
		)
	)


	!bat_echolog! '    Cal file in "!bat_archivedfilesdir!\FTPdetectinfo.txt":
	!bat_echolog! '    "!bat_latestcal!"
	if defined bat_latestcal (
		set bat_retval=success
	)
	
:APPLYAUTO_END
!bat_echolog! return-:APPLYAUTO [!bat_retval!, "!bat_latestcal!"]
%bat_return%





:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "!bat_archivedfilesdir!\%%a"
		echo     call WaitForFile rw "!bat_archivedfilesdir!\%%a"
		         call WaitForFile rw "!bat_archivedfilesdir!\%%a"
	)
	echo.
%bat_return%



	rem 10. Confirmation ******************************************
:CONFIRM
	set bat_confirmdetect=FTPdetectinfo.txt
	if /i "!bat_submissionfilesdir!" neq "" (
			echo.
			echo You probably don't want to do this - you have already run Confirm and Submit.  
			echo Choose "Undo submission" if you need to perform confirmation. 
			set /p bat_choice=Press [enter] to go back to the menu. 
			goto :CONFIRM_END
		)
	)

:CONFIRM2
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :CONFIRM_END
	)
	
	call :GETCONFIRMEDCOUNT

	echo.
	echo When asked to "Navigate to FTP Detection File to Process 
	echo for Coincidence", instead navigate to and select:
	echo   "!bat_archivedfilesdir!\!bat_confirmdetect!". 
	echo.
	echo start !bat_exedir!\FTP_Confirmation.exe "!bat_archivedfilesdir!\!bat_confirmdetect!"
	     start !bat_exedir!\FTP_Confirmation.exe "!bat_archivedfilesdir!\!bat_confirmdetect!"

	call :GETCONFIRMEDCOUNT

:CONFIRM_END
%bat_return%




:GETCONFIRMEDCOUNT
!bat_echolog! call :GETCONFIRMEDCOUNT %*
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETCONFIRMCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
		if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
				goto :GETCONFIRMEDCOUNT_END
			)
		)
	)


	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_confirmedcal=%%a
	)

	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_echolog! return-:GETCONFIRMEDCOUNT [!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!]
%bat_return%




	rem 11. Edit comments.txt file ********************************
:EDITCOMMENTS
	if not exist "!bat_confirmedfilesdir!" (
		md "!bat_confirmedfilesdir!"
	)

	cd /d "!bat_targetlocation!\CAMS"
	echo start notepad "!bat_targetlocation!\CAMS\ConfirmedFiles\!bat_archdirname!\comments.txt"
	     start notepad "!bat_targetlocation!\CAMS\ConfirmedFiles\!bat_archdirname!\comments.txt"
	cd /d !bat_exedir!
%bat_return%



	rem 12. Apply cal to ConfirmedFiles **************************
:APPLYCONFIRMED
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=Not supported from SubmissionFiles. Use "Undo Submission" if necessary: 
		goto :APPLYCONFIRMED_END
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :APPLYCONFIRMED_END
	)
	
	set bat_archivedfilesdir	
	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	
	cd /d !bat_targetlocation!\CAMS
	echo call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!"
	     call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!"
	cd /d !bat_exedir!

	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestconfcal ( set bat_latestconfcal=%%a )
	)


	pause
:APPLYCONFIRMED_END
%bat_return%





	rem 13. Submission ********************************************
	rem 13. StageFromConfirmed.bat ********************************
:SUBMITAUTO
	cd /d !bat_exedir!
	echo     call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!>>"!bat_logfile!"
	echo     call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!
	         call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!" "!bat_capturedfilesdir!" !bat_camera! !bat_autonomous!
	cd /d !bat_exedir!
	
	set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!
	set bat_submissiondirname=!bat_archdirname!
	set bat_submissiondate=!bat_captureddate!

	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`^) do ...>>"!bat_logfile!"
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
				)
			)
		)
	)
	
	
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`^) do ...>>"!bat_logfile!"
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
				)
			)
		)
	)
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"
	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	call :GETMETEORCOUNTARCHIVED
	call :GETCONFIRMEDCOUNT

!bat_echolog! return :SUBMITAUTO %* [!bat_submissionfilesdir!\!bat_camera!]
%bat_return%



:SUBMIT
echo call :SUBMIT %*
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=Not supported from SubmissionFiles. Use "Undo Submission" if necessary: 
		goto :SUBMIT_END
	)
	
	if /i "!bat_captureddate!" equ "" (
		call :CHOOSEDATE
		goto :SUBMIT
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :SUBMIT_END
	)

	if not exist "!bat_confirmedfilesdir!" (
		echo     WARNING - ConfirmedFiles does not exist ["!bat_confirmedfilesdir!"]
		rem goto :SUBMIT_END
	)



	cd /d !bat_exedir!
	echo call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!">>"!bat_logfile!"
	echo call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!"
	     call !bat_exedir!\StageFromConfirmed.bat "!bat_archivedfilesdir!"
	cd /d !bat_exedir!
	
	set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!
	set bat_submissiondirname=!bat_archdirname!
	set bat_submissiondate=!bat_captureddate!

	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
				)
			)
		)
	)
	
	
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
				)
			)
		)
	)
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"
	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	call :GETMETEORCOUNTARCHIVED
	call :GETCONFIRMEDCOUNT
	pause
:SUBMIT_END
echo return-:SUBMIT [!bat_submissionfilesdir!]
%bat_return%



	rem 14. Choose SubmissionFiles directory *********************
:CHOOSESUBMISSION
	echo.

	echo bat_captureddate="!bat_captureddate!"
	if /i "!bat_captureddate!" equ "" (
		call :CHOOSEDATE
		goto :CHOOSESUBMISSION
	)


	set bat_finddate=

	if "!bat_captureddate!" neq "" (
		set bat_finddate=%^ ^|find /i "!bat_captureddate!"
	)


	set /a bat_counter=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					echo !bat_counter!. %%a
				)
			)
		)
	)
	echo.

	if !bat_counter! equ 0 (
		set /P bat_choice=No SubmissionFiles directories found matching !bat_captureddate!. Press any key to skip. 
		goto :CHOOSESUBMISSION_END
	)
	set bat_choice=
	set /P bat_choice=Select the SubmissionFiles directory to work with: 
	if "!bat_choice!" equ "" goto :CHOOSESUBMISSION_END

	set /a bat_counter=0
	set bat_found=false
	echo Listing of SubmissionFiles:
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetlocation!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set /a bat_counter+=1
					if "!bat_counter!" equ "!bat_choice!" (
						set bat_submissionfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\%%a
						set bat_found=true
						set bat_dirname=%%~nxa
						set bat_submissiondirname=%%~nxa
						set bat_Submissiondate=!bat_dirname:~0,10!
					)
				)
			)
		)
	)
	
:CHOOSESUBMISSION1
	!bat_echolog!   :CHOOSESUBMISSION1
	if /i !bat_found! equ false goto :CHOOSEARCH
	
	
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
	)

:CHOOSESUBMISSION2
	!bat_echolog!   :CHOOSESUBMISSION2
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
					set bat_capdirname=%%a
					set bat_captureddate=!bat_capdirname:~0,10!
				)
			)
		)
	)
	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	
	
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
					set bat_archdirname=%%a
					set bat_archiveddate=!bat_archdirname:~0,10!
				)
			)
		)
	)
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"
	call :GETMETEORCOUNTARCHIVED

	call :GETCAMERAFROMSUBMISSION
	call :GETCONFIRMEDCOUNT
pause
:CHOOSESUBMISSION_END
!bat_echolog! return-:CHOOSESUBMISSION [!bat_capturedfilesdir!]
%bat_return%


:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_echolog! call :GETFILECOUNT "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_echolog! return-:GETFILECOUNT [%~1=!%1!]
%bat_return%



:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF???_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%




	rem 15. Undo Submission ***************************************
	rem Restore the Archived, Captured, and Confirmed files from 
	rem the SubmissionFiles directory to the basic CAMS subdirs
:RESTORESUBMIT

	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		set /p bat_choice=Error - SubmissionFiles not set. Use "Choose Submission dir" first: 
		goto :RESTORESUBMIT_END
	)

	call :SEARCHFORDIR "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ArchivedFiles\!bat_captureddate!*"
	set bat_archivedfilesdir=!bat_targetlocation!\CAMS\ArchivedFiles\!bat_retval3!
	set bat_archdirname=!bat_retval3!	
	echo     move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ArchivedFiles"
	         move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ArchivedFiles"
	
	echo     move /y "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"
	         move /y "!bat_archivedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"
	     
	call :SEARCHFORDIR "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\CapturedFiles\!bat_captureddate!*"
	set bat_capturedfilesdir=!bat_targetlocation!\CAMS\CapturedFiles\!bat_retval3!
	set bat_capdirname=!bat_retval3!	
	echo     move /y "!bat_retval!" "!bat_targetlocation!\CAMS\CapturedFiles"
	         move /y "!bat_retval!" "!bat_targetlocation!\CAMS\CapturedFiles"
	     
	call :SEARCHFORDIR "!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ConfirmedFiles\!bat_captureddate!*"
	set bat_confirmedfilesdir=!bat_targetlocation!\CAMS\ConfirmedFiles\!bat_retval3!
	set bat_confdirname=!bat_retval3!	
	echo     move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ConfirmedFiles"
	         move /y "!bat_retval!" "!bat_targetlocation!\CAMS\ConfirmedFiles"
	     
	echo     move /y "!bat_confirmedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"
	         move /y "!bat_confirmedfilesdir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"

	
	set bat_submissionfilesdir=
	set bat_submissiondirname=
	set bat_submissiondate=

	call :GETMETEORCOUNTARCHIVED
	call :GETCONFIRMEDCOUNT

	pause

:RESTORESUBMIT_END
!bat_echolog! return-:RESTORESUBMIT_END [!bat_capturedfilesdir!]
%bat_return%



:SEARCHFORDIR [out] bat_retval [out] bat_retval2[in]  [out] bat_retval3 bat_basedir
	rem bat_retval	is a fully qualified directory name
	rem bat_retval2 is that path not including the last directory name of the path
	rem bat_retval3 is the last directory name in the path
	
	echo :SEARCHFORDIR "%~1" 
	set bat_retval= 
	for /f "usebackq tokens=*" %%a in (`dir "%~1" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_retval=%%a
					set bat_retval2=%%~dpa::
					set bat_retval2=!bat_retval2:\::=!
					set bat_retval2=!bat_retval2:::=!
					set bat_retval3=%%~nxa
				)
			)
		)
	)

echo return-:SEARCHFORDIR: bat_retval=!bat_retval!, bat_retval2=!bat_retval2!, bat_retval3=!bat_retval3!
%bat_return%



	rem 16. Make Transmit Zip *************************************
:MAKEZIP
	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		!bat_echolog!     Run Submission before zipping: 
		if "!bat_autonomous!" neq "autonomous" (
			pause 
			goto :MAKEZIP_END
		)
	)
	
	rem This requires wzcline
	if not defined bat_camera (
		!bat_echolog!     ERROR - Please enter camera number
		goto :MAKEZIP_END
	)
	
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	
	set  bat_tempsrc=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\!bat_camera!
	set bat_tempdest=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!
	call :PREZIPMOVE "!bat_tempsrc!" "!bat_tempdest!"

	set /a bat_tempcounter=

	goto :MZ_SEVENZIP

:MZ_WINZIP
	if defined ProgramFiles(x86) (
	 	set bat_wzzip=!ProgramFiles^(x86^)!\Winzip\wzzip.exe
	 ) else (
	 	set bat_wzzip=!ProgramFiles!\Winzip\wzzip.exe
	 )
	
	 This WZZIP.exe requires user to hit ENTER.
	 set bat_wzzip_args=-p -ybc -a "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip" -r "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!"

	
	 echo call "!bat_wzzip!" !bat_wzzip_args!
	      call "!bat_wzzip!" !bat_wzzip_args!<CRLF.inp

	GOTO :MAKEZIP3

:MZ_SEVENZIP
	if exist "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" (
		if not defined bat_tempcounter (
			set /a bat_tempcounter=2
			set bat_tempdir=!bat_tempdir!_
		) else (
			set /a bat_tempcounter+=1
		)
		rem del "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip"
		goto :MZ_SEVENZIP
	)

	
	!bat_echolog! call "!bat_exedir!\7za.exe" a -r -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\*.*"
	              call "!bat_exedir!\7za.exe" a -r -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\*.*"
	GOTO :MAKEZIP3
:MAKEZIP3
	if not exist "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip" (
		!bat_echolog!     ERROR - Failed to create zip file: "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
	) else (
		!bat_echolog!     SUCCESS - "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
	)
	pause
:MAKEZIP_END
!bat_echolog! return-:MAKEZIPAUTO ["!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"]
%bat_return%


:PREZIPMOVE
	set bat_tempsrc1=%~1
	set bat_tempdest1=%~2
	
	set bat_camera
	set bat_temp

	echo     move /y "!bat_tempsrc!\EmailFiles\FTPdetectinfo_*-!bat_camera!*.txt" "!bat_tempdest!"
	         move /y "!bat_tempsrc!\EmailFiles\FTPdetectinfo_*-!bat_camera!*.txt" "!bat_tempdest!"

	echo     copy /y "!bat_tempsrc!\EmailFiles\Cal-!bat_camera!\*.txt" "!bat_tempdest!"
	    	 copy /y "!bat_tempsrc!\EmailFiles\Cal-!bat_camera!\*.txt" "!bat_tempdest!"
%bat_return%




	rem 16. Make Transmit Zip *************************************
:MAKEZIPAUTO
!bat_echolog! call :MAKEZIPAUTO %*
	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		!bat_echolog!     Run Submission before zipping: 
		if "!bat_autonomous!" neq "autonomous" (
			pause 
			goto :MAKEZIPAUTO_END
		)
	)
	
	rem This requires wzcline
	if not defined bat_camera (
		!bat_echolog!     ERROR - Please enter camera number
		goto :MAKEZIPAUTO_END
	)

	set bat_tempdir=!bat_captureddate!_!bat_camera!
	
	set  bat_tempsrc=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\!bat_camera!
	set bat_tempdest=!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!
	call :PREZIPMOVE "!bat_tempsrc!" "!bat_tempdest!"
	set /a bat_tempcounter=
	goto :MZA_SEVENZIP
	
:MZA_WINZIP
	if defined ProgramFiles(x86) (
		set bat_wzzip=!ProgramFiles^(x86^)!\Winzip\wzzip.exe
	) else (
		set bat_wzzip=!ProgramFiles!\Winzip\wzzip.exe
	)
	
	rem This WZZIP.exe requires user to hit ENTER.
	set bat_wzzip_args=-p -ybc -a "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip" -r "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!"
	
	cd /d !bat_targetlocation!\CAMS
	
	!bat_echolog! Creating "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip"
	echo call "!bat_wzzip!" !bat_wzzip_args!
	     call "!bat_wzzip!" !bat_wzzip_args!<CRLF.inp
	cd /d !bat_exedir!
	GOTO :MAKEZIPAUTO_END

:MZA_SEVENZIP
	if exist "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" (
		if not defined bat_tempcounter (
			set /a bat_tempcounter=2
			set bat_tempdir=!bat_tempdir!_
		) else (
			set /a bat_tempcounter+=1
		)
		rem del "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip"
		goto :MZA_SEVENZIP
	)
	
	!bat_echolog! call "!bat_exedir!\7za.exe" a -r -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\*.*"
	              call "!bat_exedir!\7za.exe" a -r -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!\*.*"
	GOTO :MAKEZIPAUTO_END

:MAKEZIPAUTO_END
	if not exist "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!.zip" (
		!bat_echolog!     ERROR - Failed to create zip file: "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
	) else (
		!bat_echolog!     SUCCESS - "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
	)

!bat_echolog! return-:MAKEZIPAUTO ["!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"]
%bat_return%



	rem 17. Upload Zip via FTP ************************************
:UPLOADFTP
!bat_echolog! call :UPLOADFTP %*
	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		set /p bat_choice=Run Submission before zipping: 
		goto :UPLOADFTP_END
	)

	if /i "!bat_ftppassword!" equ "" (
		set bat_choice=
		set /P bat_choice=Enter your email address as the anonymous FTP password: 
		set bat_ftppassword=!bat_choice!
		call :SAVECONFIG
	)

	set bat_ftpfile=ftp.temp.txt
set bat_ftp
	
	echo user !bat_ftpuser!>"!bat_ftpfile!"
	echo !bat_ftppassword!>>"!bat_ftpfile!"
	echo bin>>"!bat_ftpfile!"
	echo cd !bat_ftpdir!>>"!bat_ftpfile!"
	echo put "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip">>"!bat_ftpfile!"
	echo quit>>"!bat_ftpfile!"

	echo call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
type "!bat_ftpfile!"
	     call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
	     set bat_retval=!errorlevel!
	echo !bat_retval!
	
	
	!bat_echolog! '    call :MOVETRANSMIT
	                   call :MOVETRANSMIT


	echo.
	!bat_echolog! copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"
	              copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"
	pause
:UPLOADFTP_END
!bat_echolog! return-:UPLOADFTP [!bat_retval!, "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]
%bat_return%


	rem 17. Upload Zip via FTP ************************************
:UPLOADFTPAUTO
!bat_echolog! call :UPLOADFTPAUTO %*
		if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		!bat_echolog!     Run Submission before zipping: 
		if "!bat_autonomous!" neq "autonomous" (
			pause 
			goto :UPLOADFTPAUTO_END
		)
	)

	cd /d !bat_targetlocation!\CAMS
	
	set bat_ftpfile=ftp.temp.txt
	
	echo user !bat_ftpuser!>"!bat_ftpfile!"
	echo !bat_ftppassword!>>"!bat_ftpfile!"
	echo bin>>"!bat_ftpfile!"
	echo cd !bat_ftpdir!>>"!bat_ftpfile!"
	echo put "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip">>"!bat_ftpfile!"
	echo quit>>"!bat_ftpfile!"

	!bat_echolog! call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
				  call ftp -n -s:"!bat_ftpfile!" !bat_ftpsite!
	set bat_retval=!errorlevel!
	!bat_echolog! bat_retval=!bat_retval!
	cd /d !bat_exedir!
	
	!bat_echolog! '    call :MOVETRANSMIT
	                   call :MOVETRANSMIT

	!bat_echolog! copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"
	              copy /y "!bat_logfile!" "!bat_archivedfilesdir!\AutoCams2.bat.log"
:UPLOADFTPAUTO_END
!bat_echolog! return-:UPLOADFTPAUTO [!bat_retval!, "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip"]
%bat_return%


	rem Move to Transmitted
:MOVETRANSMIT
!bat_echolog! '    call :MOVETRANSMIT
	!bat_echolog! '    move /y "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" "!bat_targetlocation!\CAMS\Transmitted"
	                   move /y "!bat_targetlocation!\CAMS\Submitted\!bat_captureddate!_!bat_camera!*.zip" "!bat_targetlocation!\CAMS\Transmitted"

:MOVETRANSMIT_END
!bat_echolog! return-:MOVETRANSMIT []
!bat_return!




	rem 18. Email notice ******************************************
:EMAILTEXT
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	echo.
	echo Email the following text to your central coordinator:
	echo.
	echo     Subject: CAMS submission for Camera !bat_camera! for !bat_captureddate!
	echo.
	echo     The CAMS submission for camera !bat_camera! for !bat_captureddate! has been uploaded 
	echo     to the FTP server.  The file name is:
	echo        "!bat_tempdir!.zip"
	echo.
	echo.
	echo     Please let me know if anything of significance was found using this data.
	echo.
	set bat_emailfilesdir=!bat_targetlocation!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\EmailFiles
	for /f "usebackq tokens=*" %%h in (`dir "!bat_emailfilesdir!\arch*.txt" /b`) do (
		for /f "tokens=1-6 delims=.,=" %%i in ("!bat_emailfilesdir!\%%h") do (
			echo                     Archived    Confirmed
			echo     Meteor Count    %%j          %%l
		)
	)

	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt" /b /od /a-d`) do (
		set bat_calfilename=!bat_submissionfilesdir!\!bat_camera!\Cal\%%h
	)

	for /f "usebackq tokens=1-9 delims==" %%h in (`type "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt"`) do (
		set bat_found=0
		if "%%h" equ " Camera number            " (set bat_found=1)
		if "%%h" equ " Calibration date         " (set bat_found=1)
		if "%%h" equ " Calibration time (UT)    " (set bat_found=1)
		if "%%h" equ " Cal center Azim (deg)    " (set bat_found=1)
		if "%%h" equ " Cal center Elev (deg)    " (set bat_found=1)
		if "%%h" equ " Cam tilt wrt Horiz (deg) " (set bat_found=1)
		if "%%h" equ " Mean O-C " (set bat_found=1)
		if !bat_found! equ 1 (
			echo  %%h =%%i
		)
	)



	
::GETCALFILENSTARS	
	set /a bat_calfilestars=0
	for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "!bat_calfilename!"`) do (
		set /a "bat_calfilestars=%%j-56"
	)
	echo   Cal stars used: !bat_calfilestars!

::SHOWSKIPPEDFRAMES
	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
						 call !bat_exedir!\skippedFrames.bat "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%h"
				)
			)
		)
	)
	pause
%bat_return%
goto :EOF


:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
%bat_return%



:CHECKBINFILESIZE
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	     call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	cd /d !bat_exedir!
	pause
%bat_return%





rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
rem  =========================== UTILITY MENU ============================
:UTILSMENU
	call :CLEARSCREEN
	color !bat_color!
	if not defined bat_captureddate (
		set bat_titlebar=CAMS MENU Vers !bat_vers!
	) else (
		set bat_titlebar=CAMS MENU Vers !bat_vers!  for Captured Date: !bat_captureddate!
	)
	rem TITLE !bat_titlebar!
	TITLE %~dpnx0 - CAMS UTILITY MENU

	echo  !bat_titlebar!
	echo.
	echo  1. Command Prompt                   [ !bat_exedir!^> ]
	echo  2. CheckBinFileSize
	echo  3.    CheckBinFileSize.cleanup.bat
	echo  4. CheckFreeSpace.bat
	echo  5. ListDrives.bat
	echo  6. ValidateCal.bat
	echo  7. Meteor Count.bat                 [ presubmission ]
	echo  8. Meteor Count.bat                 [ submission ]
	echo  9. GetFFDirectoryListing.bat
	echo 10. GetCaptured.bat
	echo 11. GetArchived.bat
	echo 12. CheckTwilight             
	echo 13. Launch Capture Script
	echo 14. Multi-tasked Reprocess 
	echo 15. Post MultiScan Processing
	echo 16.    MergeCaseFiles
	echo 17. DayOfWeek
	echo 18. Save Configuration ["%~dpnx0.ini"]
	echo 19. Night Mode                       [!bat_color_on!]
	echo.	
	echo  M. Main Menu
	echo  Q. Quit
	echo.

	set bat_choice=none
	set /P bat_choice=Enter choice: 
	echo.
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" equ "m" goto :MENU
	
	if /i "!bat_choice!" equ "1" call :CMDPROMPT&goto :UTILSMENU
	if /i "!bat_choice!" equ "2" call :CHECKBINFILESIZE&goto :UTILSMENU
	if /i "!bat_choice!" equ "3" call :CHECKBINCLEANUP&goto :UTILSMENU
	if /i "!bat_choice!" equ "4" call :CHECKFREESPACE&goto :UTILSMENU
	if /i "!bat_choice!" equ "5" call :LISTDRIVES&goto :UTILSMENU
	if /i "!bat_choice!" equ "6" call :VALIDATECAL&goto :UTILSMENU
	if /i "!bat_choice!" equ "7" call :METEORCOUNTPRE&goto :UTILSMENU
	if /i "!bat_choice!" equ "7b"  call :CALUPDATEAUTO&goto :MENU
	if /i "!bat_choice!" equ "8" call :METEORCOUNTSUB&goto :UTILSMENU
	if /i "!bat_choice!" equ "9" call :GETFFDIRLIST&goto :UTILSMENU
	if /i "!bat_choice!" equ "10" call :GETCAPTURED&goto :UTILSMENU
	if /i "!bat_choice!" equ "11" call :GETARCHIVED&goto :UTILSMENU
	if /i "!bat_choice!" equ "12" call :GETTWILIGHT&GOTO :UTILSMENU
	if /i "!bat_choice!" equ "13" call :LAUNCHCAPTURE&GOTO :UTILSMENU
	if /i "!bat_choice!" equ "14"  call :REPROCESSMULTI&goto :UTILSMENU
	if /i "!bat_choice!" equ "15" call :POSTMULTI "!bat_captureddate!"&goto :UTILSMENU
	if /i "!bat_choice!" equ "16" call :MERGECASE&goto :UTILSMENU
	if /i "!bat_choice!" equ "17" call :DAYOFWEEK&goto :UTILSMENU
	if /i "!bat_choice!" equ "18" call :SAVECONFIG&goto :UTILSMENU
	if /i "!bat_choice!" equ "19" call :NIGHTMODE&goto :UTILSMENU
	if /i "!bat_choice!" equ "?" set bat_&pause&goto :UTILSMENU

	rem Hidden extras
	if /i "!bat_choice!" equ "v"  call :VARIABLES&goto :MENU
	if /i "!bat_choice!" equ "a"  call :AUTO&goto :MENU

goto :UTILSMENU



	rem u1. Command Prompt *****************************************
:CMDPROMPT
	cd /d !bat_targetlocation!
	echo start "CAMS prompt" /d "!bat_exedir!" /i "!windir!\system32\cmd.exe"
	     start "CAMS prompt" /d "!bat_exedir!" /i "!windir!\system32\cmd.exe"
	cd /d !bat_exedir!

%bat_return%



	rem u2. CheckBinFileSize **************************************
:CHECKBINCLEANUP
	echo Warning, this script can delete ff*.bin files! 
	set bat_choice=
	set /P bat_choice=Are you sure? Y/N 
	if "!bat_choice!" equ "" goto :CHECKBINCLEANUP_END
	if /i "bat_choice!" neq "y" goto :CHECKBINCLEANUP_END

	echo call CheckBinFileSize.cleanup.bat
	call CheckBinFileSize.cleanup.bat
:CHECKBINCLEANUP_END
%bat_return%



	rem u4. CheckFreeSpace *****************************************
:CHECKFREESPACE
	set bat_choice=
	set /P bat_choice=Enter drive [!bat_targetlocation:~0,2!]: 
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_targetdrive:~0,2!)
	set bat_choice=!bat_choice::=!
	set bat_choice=!bat_choice!:

	echo call CheckFreeSpace.bat !bat_choice!
	call CheckFreeSpace.bat !bat_choice!
	pause
%bat_return%



	rem u5. ListDrives *********************************************
:LISTDRIVES
	echo call ListDrives.bat
	call ListDrives.bat
	pause
%bat_return%



	rem u6. ValidateCal ********************************************
:VALIDATECAL
	set bat_temp=!bat_captureddate:~0,4!!bat_captureddate:~5,2!!bat_captureddate:~8,2!

	echo call ValidateCal.bat /cal "!bat_caldir!\CAL!bat_camera!_!bat_temp!_*.txt"
	     call ValidateCal.bat /cal "!bat_caldir!\CAL!bat_camera!_!bat_temp!_*.txt"

	pause
%bat_return%



	rem u7. Meteor Count Presubmission *****************************
:METEORCOUNTPRE
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\MeteorCount.presubmission.bat
		 call !bat_exedir!\MeteorCount.presubmission.bat
	cd /d !bat_exedir!
	
	pause
%bat_return%



	rem u8. Meteor Count Submission ********************************
:METEORCOUNTSUB
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\MeteorCount.submission.bat
		 call !bat_exedir!\MeteorCount.submission.bat
	cd /d !bat_exedir!
	pause
%bat_return%



	rem u9. GetFFDirectoryListing **********************************
:GETFFDIRLIST
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\GetFFDirectoryListing.bat !bat_dateinput!
	     call !bat_exedir!\GetFFDirectoryListing.bat !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%



	rem u10. GetCaptured *******************************************
:GETARCHIVED
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\GetArchived.bat !bat_dateinput!
	call !bat_exedir!\GetArchived.bat !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%



	rem u11. GetArchived *******************************************
:GETCAPTURED
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\GetCaptured.bat !bat_dateinput!
	     call !bat_exedir!\GetCaptured.bat !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%



	rem u12. CheckTwilight  *****************************************
:GETTWILIGHT
	rem get twilight for today or the CapturedFiles date
	set bat_twilightdate=
	if defined bat_captureddate (
		set bat_twilightdate=!bat_dateinput!
	)
	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\CheckTwilight.bat !bat_twilightdate!
	     call !bat_exedir!\CheckTwilight.bat !bat_twilightdate!
	echo.
	cd /d !bat_exedir!
	pause
%bat_return%





	rem u13. LaunchCapture  *****************************************
:LAUNCHCAPTURE
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :LAUNCHCAPTURE_END
	)
	echo.
	echo WARNING - This routine will start the capture process and it will kill
	echo           any existing running capture instances.  If capture
	echo           has already happened for this date and/or if you don't want to
	echo           start it again, you may want to quit, otherwise continue.
	echo.
:LAUNCHCAPTURE2
	set /p bat_choice=[Q]uit now.  Otherwise, [C]ontinue: 
	if /i "!bat_choice!" equ "q" goto :LAUNCHCAPTURE_END
	if /i "!bat_choice!" neq "c" goto :LAUNCHCAPTURE2
	
	echo.
	echo Notice -  You have the option to run capture in autonomous mode. In 
	echo           autonomous mode, it will complete the capture, perform a
	echo           automatic Meteor Cal Update, Apply the Cal to the detect
	echo           file, run the submission script, create a zip file, and
	echo           upload the zip file to the ftp server.
	echo.
	echo           If you choose to not run in autonomous mode, it will only
	echo           run the capture and then stop.
	echo.
	set bat_choice=
	set bat_autonomous=
	set /p bat_choice=Do you want to run in autonomous mode [Y/N] or [Q]uit? 
	if /i "!bat_choice!" equ "q" goto :LAUNCHCAPTURE_END
	if /i "!bat_choice!" equ "y" (set bat_autonomous=autonomous)
	echo.

	if not defined bat_targetlocation (
		call :CHOOSETARGETDRIVE
	)
	
	if not defined bat_camera (
		call :CHOOSECAMERA
	)
	
	cd /d !bat_exedir!
	start "LaunchCapture !bat_camera! 1 !bat_targetlocation!\" LaunchCapture !bat_camera! 1 !bat_targetlocation!\ !bat_autonomous!
	cd /d !bat_exedir!
:LAUNCHCAPTURE_END
%bat_return%



	rem u14. Reprocess **********************************************
:REPROCESSMULTI
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :REPROCESSMULTI_END
	)
	
	echo.
	echo WARNING - This routine will start the meteor scan.  It will 
	echo           delete the collection of "ftpdetectinfo.txt" like 
	echo           files that may have already been created in the 
	echo           ArchivedFiles directory from a previous run.  If 
	echo           you do NOT wish to delete and overwrite those files, 
	echo.
:REPROCESSMULTI2
	set bat_choice=
	set /p bat_choice=[Q]uit now, otherwise, [C]ontinue: 
	if /i "!bat_choice!" equ "q" goto :REPROCESSMULTI_END
	if /i "!bat_choice!" neq "c" goto :REPROCESSMULTI2
	
	echo.
	set /p 

	cd /d !bat_targetlocation!\CAMS
	echo call !bat_exedir!\makeCaseListing.bat "!bat_capturedfilesdir!"
	     call !bat_exedir!\makeCaseListing.bat "!bat_capturedfilesdir!"
	cd /d !bat_exedir!
	pause
:REPROCESSMULTI_END
%bat_return%





	rem u15. Post Multiscan ***************************************
:POSTMULTI [in] "!bat_captureddate!"
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set bat_choice=
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		if /i "!bat_choice!" equ "force" (goto :POSTMULTI2)
		goto :POSTMULTI_END
	)

:POSTMULTI2
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :POSTMULTI_END
	)
	
	cd /d !bat_targetlocation!\CAMS
	echo start "!bat_exedir!\PostMultiScanCalibration.bat !bat_archivedfilesdir!" /i cmd /c ""!bat_exedir!\PostMultiScanCalibration.bat" "!bat_archivedfilesdir!""
	     start "!bat_exedir!\PostMultiScanCalibration.bat !bat_archivedfilesdir!" /i cmd /c ""!bat_exedir!\PostMultiScanCalibration.bat" "!bat_archivedfilesdir!""
	cd /d !bat_exedir!

	set bat_temp=!bat_archivedfilesdir:ArchivedFiles=SubmissionFiles\%~1!
	if exist "!bat_temp!" (
		set bat_hasrun_post=true

		set bat_submissionfilesdir=!bat_archivedfilesdir:ArchivedFiles=SubmissionFiles\%~1!
		call :SAVECONFIG
	) else (
		echo.
		echo WARNING - "!bat_temp!" does not exist
	)
	pause
:POSTMULTI_END
%bat_return%



	rem u16. MergeCaseFiles ****************************************
:MERGECASE
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		goto :MERGECASE_END
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		goto :MERGECASE_END
	)
	
	call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archivedfilesdir!"
	
	rem Get latest cal file
	set bat_latestcal=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestcal ( set bat_latestcal=%%a )
	)


	pause
:MERGECASE_END
%bat_return%


	rem u17. DayOfWeek *********************************************
:DAYOFWEEK
	echo call DayOfWeek.bat !bat_capturedDate!
	call DayOfWeek.bat !bat_capturedDate!
	pause
%bat_return%



	rem u18. Save Configuration ************************************
:SAVECONFIG
rem !bat_echolog! call :SAVECONFIG %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=!bat_latestcal!>>"!bat_configfile!"
	echo bat_submissionfilesdir=!bat_submissionfilesdir!>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
rem !bat_echolog! return-:SAVECONFIG
%bat_return%





:READCONFIG
rem !bat_echolog! call :READCONFIG %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini

	for /f "usebackq tokens=*" %%x in (`type "!bat_configfile!"`) do (
		rem echo set %%x
		if /i "%%x" neq "[CAMSMENU]" (
		     set %%x
		)
	)

	rem set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdrive=!bat_targetlocation!
	
	call :GETMETEORCOUNTARCHIVED bat_archivedmeteorcount
	call :GETCONFIRMEDCOUNT
rem !bat_echolog! return-:READCONFIG [!bat_capturedfilesdir!]
%bat_return%



	rem u19. NIGHT MODE ************************************
:NIGHTMODE
	if not defined bat_color (
		set bat_color=47
		set bat_color_on=toggle off
	) else (
		set bat_color=
		set bat_color_on=toggle on
	)
%return%



:VARIABLES
	set bat_
	pause
%return%



:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0
	echo.
	echo Displays the CAMS menu system to facilitate access to batch scripts
	echo and processing
	echo.
	echo For autonomous mode, use the following command line options:
	echo.
	echo        %~nx0 ^<"capturedfilesdir"^> ^<"archivedfilesdir"^> ^<camera^> autonomous
	echo.
	echo Example:
	echo    %~nx0 "C:\CAMS\CapturedFiles\2011_12_25_01_33_46" "C:\CAMS\ArchivedFiles\2011_12_25_01_35_05" 299 autonomous
	echo.
exit /b 9

Needs:
	- call launchcapture (asynch)
	- call ftp_capture (asynch)
	- merge all captures for a single date
	- merge all archived for a single date (harder to do)
	- call makecaselisting (asynch)
	- call Merge cases
	- call ftp_meteorcal
	- call ftp_meteorcal_update
	- call Apply, then merge
	- skippedFrames monitoring
	- Add pick list function to choose date
	- convert all batch scripts to be able to run at the same time
	


:DONE
	call :SAVECONFIG
	echo.
	echo Done with %0 %*
	echo.
