rem @echo off

:START
	set bat_logfile=%~0.log
	echo %~0  -  %date% %time%>>"!bat_logfile!"
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	setlocal enableextensions enabledelayedexpansion

	echo %date% %time%>>"!bat_logfile!"


:CURDATETIME
	set ftp_wmdy=%date%

	set ftp_hhmmssdd=%time%

	set ftp_year=%ftp_wmdy:~-4%
	set ftp_mo=%ftp_wmdy:~4,2%
	set ftp_mo2=%ftp_mo%
	if %ftp_mo% LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	set ftp_da=%ftp_wmdy:~7,2%
	set ftp_da2=%ftp_da%
	if %ftp_da% LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

	set ftp_hr=%ftp_hhmmssdd:~0,2%
	set ftp_mi=%ftp_hhmmssdd:~3,2%
	set ftp_se=%ftp_hhmmssdd:~6,5%

	call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	rem set /a ftp_jd=%ftp_jd%-1
	call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2

:MULTIREPROCESS
	rem start the execution of the detection pass in background priority

rem start /min sndrec32 /play /close %windir%\media\ding.wav


	echo.
	echo Killing any existing FTP_Capture.exe processes that might be running...
	echo %date% %time% - calling process -k ftp_capture.exe>>"!bat_logfile!"
	echo %date% %time% - calling process -k ftp_capture.exe
	call process -k ftp_capture.exe

	echo.
	echo Starting FTP_Capture.exe...
	echo %date% %time% "FTP_Capture start" %1 %2 %3 %4>>"!bat_logfile!"
	title "[%date% %time%]  FTP_CAPTURE" %1 %2 %3 %4
	echo start "ftp_capture.exe %1 %2 %3 %4" /abovenormal /wait "ftp_capture.exe" %1 %2 %3 %4>>"!bat_logfile!"
	if exist "entervideodevice0.inp" (
	     start "ftp_capture.exe %1 %2 %3 %4" /abovenormal /wait "ftp_capture.exe" %1 %2 %3 %4<"entervideodevice0.inp"
	) else (
		if exist "entervideodevice1.inp" (
			 start "ftp_capture.exe %1 %2 %3 %4" /abovenormal /wait "ftp_capture.exe" %1 %2 %3 %4<"entervideodevice1.inp"
	    ) else (
	    	start "ftp_capture.exe %1 %2 %3 %4" /abovenormal /wait "ftp_capture.exe" %1 %2 %3 %4
	    )
	)

rem start /min sndrec32 /play /close %windir%\media\ding.wav
	echo  %date% %time% "FTP_Capture end" %1 %2 %3 %4>>"!bat_logfile!"
	echo "FTP_Capture end" %1 %2 %3 %4

	dir ".\CapturedFiles\*.*" /ad


:GETCAPTUREDIR
	rem This section is attempting to determine the directory name that FTP_Capture.exe
	rem created.  It uses the Year, Month, and Day (YYYY_MM_DD) to do a matching directory
	rem search. The last one in the list should be the most recent FTP_Capture directory.

	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%

	rem This for loop will complete with the newest directory with the specified date
	rem as the prefix.  Even if there are multiple directories with the same date, the 
	rem newest one be contained in resulting value of ftp_captureddir.

	for /f "usebackq tokens=*" %%a in (`dir "%3\CAMS\CapturedFiles\%ftp_searchdir%*.*" /b /od /ad`) do (
		echo %%~nxa
		set bat_captureddir=%3\CAMS\CapturedFiles\%%~nxa
	)
	set bat_targetsearchspec=%~3\CAMS\CapturedFiles
	
	call :MULTISCAN
	call :WAITFORMULTISCAN
	call :POSTMULTISCAN

goto :DONE


:MULTISCAN
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b`^) do...>>!bat_logfile!"
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_targetsearchspec!" /ad /s/b`) do (
		echo bat_targetsearchdir=%%~a>>"!bat_logfile!"
		set bat_targetsearchdir=%%~a
		echo bat_captureddir=%%~a>>"!bat_logfile!"
		set bat_captureddir=%%~a
	)

	echo.>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo @echo off>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo setlocal enableextensions enabledelayedexpansion>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	for /f "usebackq tokens=*" %%a in (`set`) do (
		set %%a>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	)

	echo call makeCaseListing.bat "!bat_captureddir!">>"!bat_captureddir!\rerun_makeCaseListing.bat"

	echo call makeCaseListing.bat "!bat_captureddir!">>"!bat_logfile!"
	echo call makeCaseListing.bat "!bat_captureddir!"
	     call makeCaseListing.bat "!bat_captureddir!"
%bat_return%

:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	start /w wait 60

	set bat_archivedsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedsearchspec!" /ad /s/b`^) do...>>!bat_logfile!"
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_archivedsearchspec!" /ad /s/b`) do (
		echo bat_archiveddir=%%~a>>"!bat_logfile!"
		set bat_archiveddir=%%~a
	)

	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`) do (
		echo call WaitForFile rw "%%a"
		     call WaitForFile rw "%%a"
		echo.
		echo     FINISHED with: "%%a"
	)
	
%bat_return%


:POSTMULTISCAN
	echo call PostMultiScanCalibration.bat "!bat_archiveddir!">>"!bat_logfile!"
	echo call PostMultiScanCalibration.bat "!bat_archiveddir!"
	     call PostMultiScanCalibration.bat "!bat_archiveddir!"
%bat_return%



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b 0


:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     %~n0 can be run by double-clicking on the program from 
    echo     Windows or from a command line.
    echo.
    echo     Starting it from Windows, it will run it in interactive mode 
    echo     where it will prompt the user for the camera number and the 
    echo     duration of the capture in hours.  
    echo.
    echo     If the duration entered is zero, then the user is prompted to 
    echo     manually start and stop the capture process.  If the duration 
    echo     is greater than zero, the program automatically starts the 
    echo     capture and stops after the designated time has elapsed. 
    echo.
    echo     If you run it from a command shell or batch script, you 
    echo     can specify the camera number and duration as command-line 
    echo     arguments.  If the command-line arguments don't provide all 
    echo     the necessary parameters, the missing parameters will be 
    echo     prompted for.
    echo.    
    echo     Usage: %~nx0 [cameranumber] [duration] ["targetdirectory"] [/?]
    echo.
    echo     Examples:
    echo         FTP_Capture
    echo                                          The user is prompted for 
    echo                                          camera number, duration, 
    echo                                          and base target dir.
    echo.
    echo         FTP_Capture 299                  The user is prompted for 
    echo                                          capture duration and base 
    echo                                          target dir.
    echo.
    echo         FTP_Capture 299 0.0              The user is prompted for 
    echo                                          for the base target dir and
    echo                                          prompted to start and stop. 
    echo.
    echo         FTP_Capture 299 9.5              The user is prompted for 
    echo                                          the base target dir. 
    echo.
    echo         FTP_Capture 213 8.5 "h:"   The capture for camera 299
    echo                                          starts and runs for 9 hrs  
    echo                                          and 30 mins and saves the
    echo                                          data to a directory like:
    echo                      D:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05
    echo.
    echo     Note: Directory names should be surrounded by quotes.
    echo.
    echo     A folder is created for saving the FF files based on the date and 
    echo     universal time (UTC) at the start of the capture.  The higher level 
    echo     directory is always user specified and the \CAMs\CapturedFiles\ is 
    echo     appended along with the start date and time.  For example, a 
    echo     capture that starts on Aug 14, 2011, 5:11:05 UTC and the target 
    echo     directory specified was "C:", the target directory would be created 
    echo     as C:\CAMS\CapturedFiles\2011_08_14_05_11_05.  If the target dir
    echo     of "D:\2011" is specified, the target directory would be created as:
    echo     C:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05.  
    echo.
EXIT /b 9
    
goto :DONE


:DONE
echo END OF %~nx0  ******  %date% %time%>>"!bat_logfile!"
exit /b
rem exit
