  @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


:CHECKHELP
	set bat_vers=0.978c
	set bat_calnstars=80
	set bat_caloc=2.50

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_ECHOONLY=call :ECHOONLY
	set BAT_LOG=call :LOG
	set BAT_ECHO=call :ECHOONLY

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:
	SET bat_returncode=0
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	set bat_logfile=!bat_exedir!\MergeDetect.bat.log
	set bat_mergedetectfiles_ini_file=!bat_exedir!\MergeDetectFiles.ini
	
	%bat_echolog% =============================================================...
	%bat_echolog% [%date% %time%] - %~dpnx0 %*
	%bat_echolog% Version: !bat_vers!

	set bat_returncode=0
	call :PARSEARGS %*

goto :MAIN

	
:PARSEARGS [in=%*]
!bat_echolog! call :PARSEARGS %*

	if /i "%~1" equ "" goto :HELP
	
	set bat_sourcedate=%~1
	set bat_temp_yyyy=!bat_sourcedate:~0,4!
	set bat_temp_mm=!bat_sourcedate:~5,2!
	set bat_temp_dd=!bat_sourcedate:~8,2!
	set bat_captureddate=!bat_temp_yyyy!_!bat_temp_mm!_!bat_temp_dd!

	set bat_caldir=!bat_startlocation!\Cal
	for /f "usebackq tokens=*" %%a in (`type "!bat_mergedetectfiles_ini_file!"`) do (
		echo set %%a
		     set %%a
	)


	set bat_sourcedir=!bat_1sourcedir!\!bat_captureddate!
	set bat_targetdir=!bat_1sourcedir!\!bat_captureddate!!bat_2targetdir!
	set bat_sourcefilespec=%~3
	set bat_sourcefilespecname=%~n3
	
	set bat_tempdir=!bat_exedir!\Temp
	set bat_coincidencedir=!bat_sourcedir!
	
	set bat_targetname=FTPdetectinfo_Coinc.txt
	set bat_targetfilefull=!bat_targetdir!\!bat_targetname!


!bat_echolog! return-:PARSEARGS [bat_captureddate=!bat_captureddate!]
%return%


:MAIN
!bat_echolog! goto :MAIN %*

	if not exist "!bat_1sourcedir!\!bat_sourcedate!" (
		!bat_echolog!
		!bat_echolog!
		!bat_echolog! '    ERROR - Source directory does not exist:
		!bat_echolog! '            "!bat_1sourcedir!\!bat_sourcedate!"
		!bat_echolog!
		!bat_echolog!
		goto :MAIN_END
	)

	if "!bat_1sourcedir!\!bat_sourcedate!" neq "!bat_1sourcedir!\!bat_captureddate!" (
		!bat_echolog! '    move /y "!bat_1sourcedir!\!bat_sourcedate!" "!bat_1sourcedir!\!bat_captureddate!"
						   move /y "!bat_1sourcedir!\!bat_sourcedate!" "!bat_1sourcedir!\!bat_captureddate!"
	)

	if not exist "!bat_targetdir!" (
		!bat_echolog! '    md "!bat_targetdir!"
		                   md "!bat_targetdir!"
	)

	!bat_echolog!
	!bat_echolog! '    call "MergeDetectFiles.bat" "!bat_sourcedir!" "!bat_targetdir!" "FTPdetectinfo_0*.txt" "!bat_captureddate!"
	                   call "MergeDetectFiles.bat" "!bat_sourcedir!" "!bat_targetdir!" "FTPdetectinfo_0*.txt" "!bat_captureddate!"

	!bat_echolog! '    Returned from MergeDetectFiles.bat... ending... %*

	if exist "!bat_targetfilefull!" (
		if /i "!bat_targetfilefull!" neq "!bat_sourcedir!\!bat_targetname!" (
			!bat_echolog! '    copy /y "!bat_targetfilefull!" "!bat_sourcedir!"
							   copy /y "!bat_targetfilefull!" "!bat_sourcedir!"
		)
	)
	
	if "!bat_sourcedir!" neq "!bat_targetdir!" (
		!bat_echolog! '    del /q "!bat_targetdir!"
		                   del /q "!bat_targetdir!"

		!bat_echolog! '    rd /q "!bat_targetdir!"
		                   rd /q "!bat_targetdir!"
	)

:MAIN_END
!bat_echolog! end of :MAIN %*
goto :DONE




:UNZIP
!bat_echoonly! call :UNZIP %*
	md "!bat_coincidencedir!"
	
	rem UNZIP...
	!bat_echoonly! '    call "!bat_exedir!\7unzip.bat" -y -output "!bat_coincidencedir!" "!bat_tempdir!\!bat_captureddate!*.zip" "*.*"
	                    call "!bat_exedir!\7unzip.bat" -y -output "!bat_coincidencedir!" "!bat_tempdir!\!bat_captureddate!*.zip" "*.*"
	set bat_returncode=!errorlevel!
!bat_echolog! return-:UNZIP [bat_returncode=!bat_returncode!]
%bat_return%


:MERGEDETECT
	set bat_returncode=0
	call :CREATECASEHEADER %*
	call :STRIPHEADERS %*
	call :TEMPCONCAT %*
	call :GETMETEORCOUNT %*
	call :GETFFFOLDER
	call :GETCALFOLDER
	call :REBUILDHEADER %*
	call :CONCATFINAL %*
!bat_echolog! return-:MERGEDETECT []
%bat_return%



	rem This routine puts a header file into the targetdir. If it can't copy one from 
	rem C:\CAMS, it creates a new one.
:CREATECASEHEADER
!bat_echolog! call :CREATECASEHEADER %*

	if exist "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" (
		echo '    copy /y "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" "!bat_targetdir!"
		          copy /y "!bat_exedir!\FTPdetectinfo_CaseHeader.txt" "!bat_targetdir!"
	) else (
		echo Meteor Count = 000000>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Processed with FTP 1.3 on Tue Feb 28 00:00:00 2012>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo FF  folder = c:\d\CAMS\ArchivedFiles\2011_12_29_10_05_22\>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo CAL folder = c:\d\CAMS\Cal\>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo ----------------------------------------------------->>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo FF  file processed>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo CAL file processed>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Cam# Meteor# #Segments fps hnr mle bin Pix/fm Rho Phi>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"
		echo Per segment:  Frame# Col Row RA Dec Azim Elev Inten>>"!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"

	)
!bat_echolog! return-:CREATECASEHEADER ["!bat_targetdir!\FTPdetectinfo_CaseHeader.txt"]
!bat_return!







:STRIPHEADERS
!bat_echolog! call :STRIPHEADERS [%*]
	if exist "!bat_targetfilefull!" (
		del /q "!bat_targetfilefull!"
	)
	echo '    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_sourcedir!\!bat_sourcefilespec!" /b /a-d /on`^) do ^(
	for           /f "usebackq tokens=*" %%a in  (`dir "!bat_sourcedir!\!bat_sourcefilespec!" /b /a-d /on`) do (
		set bat_temp_filename=%%~nxa
		set bat_temp_fullfilename_src=!bat_sourcedir!\!bat_temp_filename!
		set bat_temp_fullfilename_tar=!bat_targetdir!\!bat_temp_filename!
		set bat_temp_headerfull=!bat_targetdir!\header.txt
		set bat_temp_stripped=%%~na_stripped%%~xa

		if /i "!bat_temp_filename!" neq "FTPdetectinfo.txt" (
			if /i "!bat_temp_filename!" neq "!bat_targetname!" (
				if /i "!bat_temp_filename:~-13!" neq "_stripped.txt" (
					if /i "!bat_temp_filename!" neq "FTPdetectinfo_CaseHeader.txt" (
						!bat_echolog! '    call "!bat_exedir!\StripHeaderNASA.bat" "!bat_temp_fullfilename_src!" "!bat_temp_headerfull!" "!bat_targetdir!\!bat_temp_stripped!"
										   call "!bat_exedir!\StripHeaderNASA.bat" "!bat_temp_fullfilename_src!" "!bat_temp_headerfull!" "!bat_targetdir!\!bat_temp_stripped!"
					)
				)
			)
		)
	)


:STRIPHEADERS_END
!bat_return!





	rem temporary concat to fix the meteor count
	rem This section concats without the header
	rem Result: New "FTPdetectinfo.txt" file n the target dir.
:TEMPCONCAT
!bat_echolog! call :TEMPCONCAT %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	!bat_echolog! for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetdir!\!bat_sourcefilespecname!_stripped.txt" /b /a-d`^) do ...
	for               /f "usebackq tokens=*" %%a in  (`dir "!bat_targetdir!\!bat_sourcefilespecname!_stripped.txt" /b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%bat_targetdir%\%%~a"
		) else (
			set bat_string=!bat_string!+"%bat_targetdir%\%%~a"
		)
	)
	!bat_echolog! '    copy /y /b !bat_string! "!bat_targetdir!\!bat_targetname!"
	                   copy /y /b !bat_string! "!bat_targetdir!\!bat_targetname!"

	set bat_caseheaderfile=!bat_targetdir!\FTPdetectinfo_CaseHeader.txt

!bat_echolog! return-:TEMPCONCAT [!bat_string!]
%bat_return%




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT [out=bat_count]
!bat_echolog! call :GETMETEORCOUNT %*
	if not exist "!bat_targetdir!\!bat_targetname!" (
		!bat_echolog! '    ERROR - file not found: "!bat_targetdir!\!bat_targetname!"
		set bat_returncode=1
		goto :ABORT
	)
	
	
	!bat_echoonly! '    for /f "usebackq tokens=1-4" ..a in ^(`find /i /c ".bin" "!bat_targetdir!\!bat_targetname!"`^) do ^(
	for                     /f "usebackq tokens=1-4" %%a in  (`find /i /c ".bin" "!bat_targetdir!\!bat_targetname!"`) do (
		!bat_echoonly! '    set bat_count=%%c
		                    set bat_count=%%c
	)

	!bat_echoonly! '    for /f "usebackq tokens=*" a in ^(`type "!bat_caseheaderfile!" find /i "Meteor Count = "`^) do ^(
	for                     /f "usebackq tokens=*" %%a in (`type "!bat_caseheaderfile!"^|find /i "Meteor Count = "`) do (
		!bat_echoonly! '    set bat_countsrc=%%a
		                    set bat_countsrc=%%a
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!
	set bat_countdest=Meteor Count = !bat_count!


!bat_echolog! return-:GETMETEORCOUNT [!bat_countdest!]
%bat_return%



:GETFFFOLDER [out=bat_fffoldersrc]
!bat_echolog! call :GETFFFOLDER %*
	!bat_echoonly! '    for /f "usebackq tokens=*" a in ^(`type  "!bat_caseheaderfile!"^|find /i "FF  folder"`^) do ^(
	for                     /f "usebackq tokens=*" %%a in (`type  "!bat_caseheaderfile!"^|find /i "FF  folder"`) do (
		set bat_fffoldersrc=%%a
	)
!bat_echolog! return-:GETFFFOLDER ["!bat_fffoldersrc!"]
!bat_return!


:GETCALFOLDER [out=bat_calfoldersrc]
!bat_echolog! call :GETCALFOLDER %*
	!bat_echoonly! '    for /f "usebackq tokens=*" a in ^(`type  "!bat_caseheaderfile!"^|find /i "CAL folder"`^) do ^(
	for                    /f "usebackq tokens=*" %%a in (`type  "!bat_caseheaderfile!"^|find /i "CAL folder"`) do (
		set bat_calfoldersrc=%%a
	)
!bat_echolog! return-:GETCALFOLDER ["!bat_calfoldersrc!"]
!bat_return!



	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
!bat_echolog! :REBUILDHEADER %*

	set bat_findstr=!bat_fffoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=FF  folder = !bat_targetdir!\
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	set bat_detectfile=FTPdetectinfo.txt
	if /i "%~2" neq "" (
		set bat_detectfile=%~2
	)
	
	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"


	set bat_calfolder=!bat_targetdir!\

	set bat_findstr=!bat_calfoldersrc!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_findstr_c=!bat_findstr:\=\\!
	set bat_findstr_c=!bat_findstr_c::=\:!

	set bat_replstr=CAL folder = !bat_caldir!
	rem The ReplaceText.exe tool requires that the colons and backslashes are escaped
	set bat_replstr_c=!bat_replstr:\=\\!
	set bat_replstr_c=!bat_replstr_c::=\:!

	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"

	set bat_findstr_c=!bat_countsrc!

	set bat_replstr_c=!bat_countdest!

	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iCV "!bat_caseheaderfile!" "!bat_findstr_c!" "!bat_replstr_c!"

	echo.
	echo.
	echo type "!bat_caseheaderfile!"
	echo.
	for /f "usebackq tokens=*" %%a in (`type "!bat_caseheaderfile!"`) do (
		echo     %%~a
	)
	echo.
	echo.
!bat_echolog! return-:REBUILDHEADER [see output above from the command: type "!bat_caseheaderfile!"]
%bat_return%




:CONCATFINAL
!bat_echolog! call :CONCATFINAL [!bat_caseheaderfile!, !bat_string!, !bat_targetfilefull!]
	echo     copy /y /b "!bat_caseheaderfile!"+!bat_string! "!bat_targetdir!\!bat_targetname!"
	         copy /y /b "!bat_caseheaderfile!"+!bat_string! "!bat_targetdir!\!bat_targetname!"


	echo '    del "!bat_caseheaderfile!"
	          del "!bat_caseheaderfile!"
rem
	echo.
	if not exist "!bat_targetfilefull!" (
:CONCATPROMPT
		echo Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		echo file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		echo the following command:
		echo    %~0 %*
		set bat_choice=
		set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE
:CONCATFINAL_END
!bat_echolog! return-:CONCATFINAL ["!bat_targetfilefull!"]
%bat_return%




		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"

		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdir!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdir!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_echolog! call :FIXDETECTPATHS [%*, !bat_detectfile!]
	set bat_retval=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)
	
	set bat_detectfile=FTPdetectinfo.txt
	if /i "%~2" neq "" (
		set bat_detectfile=%~2
	)
	
	set bat_calfolder=!bat_targetdir!\Cal

	rem convert bat_fffoldersrc to C-style string
	set bat_fffoldersrc_c=!bat_fffoldersrc:\=\\!
	set bat_fffoldersrc_c=!bat_fffoldersrc_c::=\:!
	
	set bat_fffolderdest=!bat_targetdir!\ArchivedFiles\
	set bat_fffolderdest_c=!bat_fffolderdest:\=\\!
	set bat_fffolderdest_c=!bat_fffolderdest_c::=\\!

	!bat_echolog! '    call "!bat_exedir!\ReplaceText.exe" -iC "!bat_targetdir!\!bat_detectfile!" "!bat_fffoldersrc_c!" "!bat_fffolderdest_c!"
	                   call "!bat_exedir!\ReplaceText.exe" -iC "!bat_targetdir!\!bat_detectfile!" "!bat_fffoldersrc_c!" "!bat_fffolderdest_c!"


	!bat_echolog! '    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!

	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_echolog! return-:FIXDETECTPATHS [!bat_recent_error_msg!]
!bat_return!


:COPYPARAMFILES
!bat_echolog! call :COPYPARAMFILES %*
	!bat_echolog! '    copy /y "!bat_exedir!\CoincidenceParameters.txt" "!bat_exedir!\versionHistory"
	                   copy /y "!bat_exedir!\CoincidenceParameters.txt" "!bat_exedir!\versionHistory"

	!bat_echolog! '    copy /y "!bat_caldir!\CameraSites.txt" "!bat_targetdir!"
	                   copy /y "!bat_caldir!\CameraSites.txt" "!bat_targetdir!"

	!bat_echolog! '    copy /y "!bat_caldir!\CameraSites.txt" "!bat_targetdir!\Cal"
	                   copy /y "!bat_caldir!\CameraSites.txt" "!bat_targetdir!\Cal"

	!bat_echolog! '    copy /y "!bat_exedir!\CameraTimeOffsets.txt" "!bat_targetdir!"
	                   copy /y "!bat_exedir!\CameraTimeOffsets.txt" "!bat_targetdir!"

	!bat_echolog! '    copy /y "!bat_caldir!\w902*.txt" "!bat_targetdir!"
	                   copy /y "!bat_caldir!\w902*.txt" "!bat_targetdir!"

	!bat_echolog! '    copy /y "!bat_caldir!\CameraTimeOffsets.txt" "!bat_targetdir!"
	                   copy /y "!bat_caldir!\CameratimeOffsets.txt" "!bat_targetdir!"

!bat_echolog! return-:COPYPARAMFILES []
!bat_return!






:COINCIDENCE
!bat_echoonly! call :COINCIDENCE %*
	!bat_echolog! '    call "!bat_exedir!\versionHistory\FTP_Coincidence.exe" "!bat_targetfilefull!"
	                   call "!bat_exedir!\versionHistory\FTP_Coincidence.exe" "!bat_targetfilefull!"

!bat_echolog! return-:COINCIDENCE []
!bat_return!

























































:GETCAMERAFROMARCHIVED
	set /a bat_archivedcount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF???_*.bin" /b /a-d`) do (
		set /a bat_archivedcount+=1
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%


:GETMETEORCOUNTARCHIVED
!bat_echolog! call :GETMETEORCOUNTARCHIVED %*
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
           
		if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			
			if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
				set bat_latestcal=
				set /a bat_archivedmeteorcount=0
				
				goto :GETMETEORCOUNTARCHIVED_END
			)
		)
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETMETEORCOUNTARCHIVED_END
	)

	set bat_latestcal=
	set /a bat_archivedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_archivedmeteorcount+=1
		set bat_latestcal=%%a
	)
	
:GETMETEORCOUNTARCHIVED_END
!bat_echolog! return-:GETMETEORCOUNTARCHIVED [!bat_archivedmeteorcount!, !bat_latestcal!, !bat_archivedfilesdir!\!bat_detectfile!]
%bat_return%




:GETCONFIRMEDCOUNT
!bat_echolog! call :GETCONFIRMEDCOUNT %*
	if /i "!bat_archivedfilesdir!" equ "" (
		goto :GETCONFIRMEDCOUNT_END
	)

	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	set bat_detectfile=FTPdetectinfo.txt

	if /i "!bat_submissionfilesdir!" neq "" (
		set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
		if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
			set bat_detectfile=FTPdetectinfo.txt
			if not exist "!bat_confirmedfilesdir!\!bat_detectfile!" (
				goto :GETCONFIRMEDCOUNT_END
			)
		)
	)


	set bat_confirmedcal=
	set /a bat_confirmedmeteorcount=0
	!bat_echolog! for /f "usebackq tokens=*" %%a in ^(`find /i ".bin" "!bat_confirmedfilesdir!\!bat_detectfile!"`^) do ...
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\!bat_detectfile!"`) do (
		set /a bat_confirmedmeteorcount+=1
		set bat_confirmedcal=%%a
	)

	call :SAVECONFIG

:GETCONFIRMEDCOUNT_END
!bat_echolog! return-:GETCONFIRMEDCOUNT [!bat_confirmedmeteorcount!, bat_confirmedcal=!bat_confirmedcal!, !bat_confirmdetect!]
%bat_return%




:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_echolog! call :GETFILECOUNT "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_echolog! return-:GETFILECOUNT [%~1=!%1!]
%bat_return%



:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF???_*.bin" /b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%






:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
%bat_return%







:VARIABLES
	set bat_
	pause
%return%


:FIXDETECTPATHS [folder, !bat_detectfile!]
!bat_echolog! call :FIXDETECTPATHS [%*, !bat_detectfile!]
	set bat_retval=0
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=NOT SUPPORTED - You you have already run Submission. 
		goto :FIXDETECTPATHS_END
	)

	!bat_echolog! '    call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	                   call "!bat_exedir!\FixDetectPaths.bat" "%~1" %2
	set bat_retval=!errorlevel!
	if !bat_retval! neq 0 (
		set bat_recent_error_msg=ERROR - Unable to patch paths in detect file "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
		goto :FIXDETECTPATHS_END
	) else (
		set bat_recent_error_msg=SUCCESS - FixDetectPaths.bat "%~1\%2"
		!bat_echolog! '    !bat_recent_error_msg!
	)
:FIXDETECTPATHS_END
!bat_echolog! return-:FIXDETECTPATHS [!bat_recent_error_msg!]
!bat_return!




:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%


:ECHOONLY
	rem Echo to the console
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%
%bat_return%








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 "<date>" 
	echo.
	echo Example: 
	echo   MergeDetect.bat "2012-01-31"
	echo.
	echo Strips the header section from each detect file matching the 
	echo "FTPdetectinfo_0*.txt". 
	echo Then it combines the remaining data into a single detect file that 
	echo can be used during coicidence processing with a new header. 
	echo.
	echo All this is accomplished by calling MergeDetectFiles.bat using the following
	echo syntax:
	echo   MergeDetectFiles.bat "C:\CAMS\data\<date>" "C:\CAMS\data\<date>\Merged" "FTPdetectinfo_0*.txt" "<date>"
	echo.
	echo.
	echo The MergeDetectFiles.ini file can be used to configure some of the settings, such as the 
	echo Cal directory. 
	echo.
	echo.
exit /b 9

Needs:
	- 
	
:ABORT
	!bat_echolog! '    ABORTING
	!bat_echolog! '    bat_returncode=!bat_returncode!
	pause
exit /b !bat_returncode!

:DONE
	rem call :SAVECONFIG
	echo.
	echo Done with %0 %*
	echo.
exit /b !bat_returncode!