  @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


:CHECKHELP
		echo.%*|find /i "/?">nul:
		if %errorlevel% equ 0 goto :HELP
		echo.%*|find /i "/h">nul:
		if %errorlevel% equ 0 goto :HELP
		echo.%*|find /i "/help">nul:
		if %errorlevel% equ 0 goto :HELP
goto :SETUP %*


:SETUP
	echo =============================================================
	echo %date% %time% - %~dpnx0 [%*]

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:

	set bat_logfile=!bat_exedir!\Zipdir_7za.bat.log
	
	set bat_submissiondir=%~1
	set bat_submissionbasedir=%~dp1::
	set bat_submissionbasedir=!bat_submissionbasedir:\::=!
	set bat_submissionbasedir=!bat_submissionbasedir:::=!
	
	set bat_targetzipfilename=%~nx1.zip
	set bat_targetfullzipfile=!bat_submissionbasedir!\!bat
goto :MAIN %*
	

:MAIN

	dir "!bat_submissiondir!\CapturedFiles" /s/b /ad
	if !errorlevel! neq 0 (
		echo call "!bat_exedir!\7za.exe" a -r -tzip "!bat_submissionbasedir!\!bat_targetzipfilename!" "!bat_submissiondir!"
			 call "!bat_exedir!\7za.exe" a -r -tzip "!bat_submissionbasedir!\!bat_targetzipfilename!" "!bat_submissiondir!"

		echo dir "!bat_submissionbasedir!\!bat_targetzipfilename!" /b /a-d
		     dir "!bat_submissionbasedir!\!bat_targetzipfilename!" /b /a-d

		echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionbasedir!\!bat_targetzipfilename!" /s/b /a-d`^) do ...
		for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionbasedir!\!bat_targetzipfilename!" /s/b /a-d`) do (
			set bat_tempfull=!bat_submissionbasedir!\%%a
			set bat_dirname=%%~dpa::
			set bat_dirname=!bat_dirname:\::=!
			set bat_dirname=!bat_dirname:::=!
			set bat_zipsize=%%~za
			
			echo bat_tempfull=!bat_tempfull!
			echo bat_dirname=!bat_dirname!
			echo bat_zipsize=!bat_zipsize!
			
			if /i !bat_zipsize! GTR 100 (
				echo move /y "!bat_submissiondir!" "!bat_submissiondir!_zipped"
				     move /y "!bat_submissiondir!" "!bat_submissiondir!_zipped"
			)
		)
	) else (
		echo xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
		echo xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
		echo Skipped "!bat_submissiondir!>>"!bat_logfile!"
		echo Skipped "!bat_submissiondir!
	)


goto :DONE %*


:HELP
	echo =============================================================
	echo %date% %time% - %~dpnx0 [%*]
	echo.
	echo Usage %~nx0 sourcedir
	echo.
	echo Example:
	echo    for /f "usebackq tokens=*" %%a in ^(`dir "e:\cams\SubmissionFiles\2011_08_??" /ad /b /on`^) do ^(call ^"c:\cams\zipdir_7za.bat^"  ^"e:\cams\SubmissionFiles\%%a^"^)
	echo.
	echo    This will zip each dir in that matches the filespec, "2011_08_??". It will 
	echo    rename the source directory to "source_zipped" if the zip is successful.  
	echo    Example: "2011_08_20"  will be renamed to "2011_08_20_zipped"
	echo.
	echo    It will not delete the "..._zipped" directory.  You will need to do
	echo    that on your own.
	echo.
	echo    The compression ration seems to be about 35%-40%
	echo.
	echo Note: This uses the Seven-Zip commandline utility (7za.exe)
	echo.

	
:DONE
