@echo off
setlocal enableextensions enabledelayedexpansion

echo %~dp0

:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	wmic /?>nul:
	if %errorlevel% equ 9009 (
		exit /b
		set bat_free=9999999
		set bat_size=9999999
		set bat_freeMB=999999999
	)

rem set default test duration at 14 hours
set bat_durtotalseconds=50400
set bat_targetlocation=%cd%

	set bat_warningfile=%~0.warn.txt
	set bat_tempfile=%~0.junk.txt
	
	set bat_temp3=%cd%
	
	if "%~1" neq "" (
		set bat_targetlocation=%~dpnx1
		rem remove trailing backslash
		set bat_temp3=%~dp1
		set bat_temp2=!bat_temp3:~0,-1!
	)
	
	
	set bat_targetdrive=!bat_targetlocation:~0,2!
	


	rem Note: We have to do it this way because WMIC outputs unicode and
	rem FINDSTR is not compatible with unicode strings.
	wmic /node:localhost logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:csv>"!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-2* skip=1" %%a in (`type "!bat_tempfile!"^|findstr /r /c:","`) do (
		set bat_free=%%b
		set bat_size=%%c
		if "!bat_free!" neq "" (
			set bat_freeMB=!bat_free:~0,-6!
		)
	)


:CHECK

	set /a bat_estCapFiles=!bat_durtotalseconds/8
	set /a bat_estSizeMB=!bat_estCapFiles!*1229/1000
	set /a bat_sizediff=!bat_estSizeMB!-!bat_freeMB!

	if !bat_estSizeMB! gtr !bat_freeMB! (
		echo call :GETWINDOWSVER
		call :GETWINDOWSVER
		
		set /a bat_sizediff=!bat_estSizeMB!-!bat_freeMB!

		ECHO ********* WARNING! ************>!bat_warningfile!
		echo    You only have !bat_freeMB! MB free on drive !bat_targetdrive!. This >>!bat_warningfile!
		echo    run will require !bat_estSizeMB! MB.  You will need to free up>>!bat_warningfile!
		echo    !bat_sizediff! MB before ASAP or the capture will fail.>>!bat_warningfile!
		echo.>>!bat_warningfile!
		echo    Tips ^(!bat_winver!^):>>!bat_warningfile!
		echo      a^) Try emptying the recycle bin >>!bat_warningfile!
		if "bat_winver" lss "6.0" (
			echo           ^(rd /s !bat_targetdrive!\recycler^)>>!bat_warningfile!
		) else (
		    echo           ^(rd /s !bat_targetdrive!\$Recycle.Bin^)>>!bat_warningfile!
		)
		echo      b^) Use Disk Cleanup to free up temporary space and other areas.>>!bat_warningfile!
		echo      c^) Move "!bat_targetlocation!CAMS\SubmissionFiles" to an external hard drive.>>!bat_warningfile!
		echo      d^) Move "!bat_targetlocation!CAMS\CapturedFiles" to an external hard drive.>>!bat_warningfile!
		echo.
		type "!bat_warningfile!"
		start /max notepad "!bat_warningfile!"
	) else (
		echo     PASSED
		echo        You have !bat_freeMB! MB free on drive !bat_targetdrive!. This run will
		echo        require only !bat_estSizeMB! MB.  You should not encounter
		echo        disk space issues during the run.
		echo.
	)
exit /b

:GETWINDOWSVER
	echo :GETWINDOWVER wmic os get version, caption, windowsdirectory /format:list^|findstr /r /c:"=" ... "!bat_tempfile!"
	wmic os get version, windowsdirectory /format:csv|findstr /r /c:",">"!bat_tempfile!"
	type "!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-4*" %%a in (`type "!bat_tempfile!"`) do (
		if "%%b" gtr "!" (
			set bat_winver=%%b
		)
	)
goto :EOF

:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     Usage: %~nx0 [date]" [/?]
    echo.
    echo     If you specify a date, it can give you the required disk space
    echo     for that date.  If you leave the date off, it will estimate
    echo     based on 14 hours of nighttime caputuring.
exit /b
