setlocal enableextensions enabledelayedexpansion
@echo off

set bat_exedir=%~dp0::
set bat_exedir=!bat_exedir:\::=!
set bat_exedir=!bat_exedir:::=!

:SETUP
	set return=goto :EOF
	
	dir ArchivedFiles /ad /s/b
	dir CapturedFiles /ad /s/b
	dir ConfirmedFiles /ad /s/b

	for /f "usebackq tokens=*" %%a in (`dir CapturedFiles /s/b /ad`) do (
		set bat_Captured=%%~dpa::
		set bat_Captured=!bat_Captured:\::=!
		set bat_Captured=!bat_Captured:::=!
		
		set bat_dirnameCap=%%~na
		set bat_datespecCap=!bat_dirnameCap:~0,4!!bat_dirnameCap:~5,2!!bat_dirnameCap:~8,2!
	)
	
	echo bat_exedir=!bat_exedir!
	echo bat_captured=!bat_captured!
	echo bat_dirnameCap=!bat_dirnameCap!
	echo bat_datespecCap=!bat_datespecCap!
	set bat_calfilespec=!bat_exedir!\Cal\Cal213_!bat_datespecCap!*.*
	echo bat_calfilespec=!bat_calfilespec!
	
	echo.
	echo ============
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_exedir!\ArchivedFiles\ftpdetectinfo.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\ArchivedFiles\ftpdetectinfo.txt" /s/b /a-d`) do (
		find /i "Meteor Count" "%%~fa"
	)
	echo.
	
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_captured!\!bat_dirnameCap!" /s/b /a-d^|find /c ".bin"`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_captured!\!bat_dirnameCap!" /s/b /a-d^|find /c ".bin"`) do (
		echo Total Captured Files: %%~a
	)
	echo.
	
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_exedir!\ConfirmedFiles\ftpdetectinfo.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\ConfirmedFiles\ftpdetectinfo.txt" /s/b /a-d`) do (
		find /i "Meteor Count" "%%~fa"
	)
	echo.
	
pause
	echo call FTP_MeteorCal_Update
	call FTP_MeteorCal_Update


	echo dir "!bat_calfilespec!" /s/b /a-d /od
	for /f "usebackq tokens=*" %%a in (`dir "!bat_calfilespec!" /s/b /a-d /od`) do (
		echo             %%~nxa
		set bat_calfile=%%~nxa
		set bat_calfile=!bat_calfile:~0,18!
	)
	echo bat_calfile=!bat_calfile!
	pause


	for /f "usebackq tokens=*" %%a in (`dir "ArchivedFiles\FTPdetectinfo.txt" /s/b /a-d`) do (
		set bat_archfullpath=%%~fa
		set bat_archpath=%%~dpa::
		set bat_archpath=!bat_archpath:\::=!
		set bat_archpath=!bat_archpath:::=!
		

		echo notepad "!bat_archfullpath!"
		echo.
		notepad "!bat_archfullpath!"
		
		echo call FTP_ApplyCal2Detectinfo.exe
		call FTP_ApplyCal2Detectinfo.exe

		echo move /y "!bat_archpath!\FTPdetectinfoC.txt" "!bat_archfullpath!"
		     move /y "!bat_archpath!\FTPdetectinfoC.txt" "!bat_archfullpath!"
		     
		echo find /i /c "!bat_calfile!" "!bat_archfullpath!"
		     find /i /c "!bat_calfile!" "!bat_archfullpath!"
		if !errorlevel! neq 0 (
			echo ERROR - didn't update: "!bat_archfullpath!"
			exit /b
		)
	)
	
pause

	echo for /f "usebackq tokens=*" %%a in ^(`dir "ConfirmedFiles\FTPdetectinfo.txt" /s/b /a-d`^) do...
	for /f "usebackq tokens=*" %%a in (`dir "ConfirmedFiles\FTPdetectinfo.txt" /s/b /a-d`) do (
		set bat_conffullpath=%%~fa
		set bat_confpath=%%~dpa::
		set bat_confpath=!bat_confpath:\::=!
		set bat_confpath=!bat_confpath:::=!
		

		echo notepad "!bat_conffullpath!"
		echo.
		notepad "!bat_conffullpath!"
		
		echo call FTP_ApplyCal2Detectinfo.exe
		call FTP_ApplyCal2Detectinfo.exe

		echo move /y "!bat_confpath!\FTPdetectinfoC.txt" "!bat_conffullpath!"
		     move /y "!bat_confpath!\FTPdetectinfoC.txt" "!bat_conffullpath!"
		
		echo find /i /c "!bat_calfile!" "!bat_conffullpath!"
		     find /i /c "!bat_calfile!" "!bat_conffullpath!"
		if !errorlevel! neq 0 (
			echo ERROR - didn't update: "!bat_conffullpath!"
			exit /b
		)
	)

set bat_
echo Pause before SUBMISSION.BAT "!bat_confpath!"
pause
	call submission.bat "!bat_confpath!"

	set bat_error=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "CapturedFiles\*.bin" /s/b /a-d^|find /c ".bin"`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "CapturedFiles\*.bin" /s/b /a-d^|find /c ".bin"`) do (
		if "!bat_error!" neq "0" (
			echo ERROR - not empty - "%%~fa"
		) else (
			echo OK - %%a files found
		)
	)
	
	set bat_error=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "ArchivedFiles\*.bin" /s/b /a-d^|find /c ".bin"`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "ArchivedFiles\*.bin" /s/b /a-d^|find /c ".bin"`) do (
		if "!bat_error!" neq "0" (
			echo ERROR - not empty - "%%~fa"
		) else (
			echo OK - %%a files found
		)
	)
	
	set bat_error=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "ConfirmedFiles\*.bin" /s/b /a-d^|find /c ".bin"`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "ConfirmedFiles\*.bin" /s/b /a-d^|find /c ".bin"`) do (
		if "!bat_error!" neq "0" (
			echo ERROR - not empty - "%%~fa"
		) else (
			echo OK - %%a files found
		)
	)
	
	
exit /b

:COPYCALFILE
	call :COPYCALFF "!bat_emailfilesdir!\Cal-213\!bat_calfilename!"
%return%
	

	rem read the cal file and use the date on line 2 and the time on 
	rem line 3 to create a search for the cal file.  To use the following
	rem example, the search will search in reverse order for the ff*.bin
	rem files from the CapturedFiles directory.
	rem Here is the format of the cal file
1	 Camera number            = 213
2	 Calibration date         = 08/18/2011
3	 Calibration time (UT)    = 03:38:09.187
:COPYCALFF
	echo :COPYCALFF %*

	set /a bat_calff_line=0
	echo for /f "usebackq tokens=1-5" %%f in (`type "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"`) do 
	for /f "usebackq tokens=1-5" %%f in (`type "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"`) do (
		set /a bat_calff_line+=1
		if !bat_calff_line! equ 2 (
			rem date
			rem echo %%f, %%g, %%h, %%i, %%j
			set bat_calffdate=%%i
			set bat_calffyyyy=!bat_calffdate:~-4!
			set bat_calffmm=!bat_calffdate:~0,2!
			set bat_calffdd=!bat_calffdate:~3,2!
		) else (
			if !bat_calff_line! equ 3 (
				rem time
				rem echo %%f, %%g, %%h, %%i, %%j
				set bat_calfftime=%%j
				set bat_calffhh=!bat_calfftime:~0,2!
				set bat_calffm=!bat_calfftime:~3,2!
				set bat_calffss=!bat_calfftime:~6,2!
			) else (
				rem ignore 
			)
		)
	)
	
	set bat_filespec=!bat_calffhh!!bat_calffm!!bat_calffss!
	set bat_searchspec=FF!bat_camera!_!bat_calffyyyy!!bat_calffmm!!bat_calffdd!_
	
	set bat_calff_found=0
rem echo	for /f "usebackq tokens=*" %%f in (`dir !bat_submitcapturedbase!\!bat_searchspec!*.* /s/b /o-n`) do 
	for /f "usebackq tokens=*" %%f in (`dir "!bat_submitcapturedbase!\!bat_searchspec!*.*" /s/b /o-n`) do (
		rem
		set bat_tempfilefull=%%f
		set bat_tempfilename=%%~nxf
		set bat_tempyyyy=!bat_tempfilename:~6,4!
		set bat_tempmm=!bat_tempfilename:~10,2!
		set bat_tempdd=!bat_tempfilename:~12,2!
		set bat_temphh=!bat_tempfilename:~15,2!
		set bat_tempmin=!bat_tempfilename:~17,2!
		set bat_tempsec=!bat_tempfilename:~19,2!
		
		set bat_tempspec=!bat_temphh!!bat_tempmin!!bat_tempsec!
		
		if !bat_found! equ 0 (
			if !bat_tempspec! lss !bat_filespec! (
				set bat_found=!bat_tempfilefull!
				set bat_calffname=!bat_tempfilefull!
				echo                                      FOUND "!bat_found!"
				echo copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
				copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
			) else (
				rem echo NOT FOUND
				rem set bat_
				rem pause
			)
		)
		
		
	)
%return%


