 @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


echo %~nx0

:CHECKHELP
	set bat_vers=0.961

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	set bat_camerahint=+
	set return=goto :EOF
	set bat_return=goto :EOF
	
	set bat_startlocation=%cd%&					rem C:\CAMS
	set bat_startdrive=%cd:~0,2%&				rem C:
	
	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_logfile=!bat_startdrive!\cams\%~0.log
	
	set bat_hasrun_post=false
	set bat_hasrun_reprocess=false
	set bat_hasrun_calupdate
	set bat_hasrun_cal
	set bat_hasrun_confirm
	set bat_hasrun_submission
	set bat_hasrun_zip

	call :READCONFIG	
goto :MENU

	if not exist "!bat_mainspec!\!bat_getdirname!" (
		echo     ERROR: specified source dir doesn't exist:^("!bat_mainspec!\!bat_getdirname!"^)
		exit /b 1
	) else (
		echo     bat_mainspec=!bat_mainspec!
	)


	
:PARSEARGS
	rem call :PARSEARGS %~1 %~dp1 %~nx1
echo :PARSEARGS %1, %~dp1, %~nx1
	set bat_getdirname=%~nx1
	set bat_mainspec=!bat_startlocation!\ArchivedFiles
	set bat_arg1=%~1
	set bat_mainfilter=^|find /i "!bat_getdirname!"
	
	if "!bat_arg1!" neq "" (
		if ":" equ "!bat_arg1:~1,1!" (
			echo     Format: x:\CAMS\ArchivedFiles\date/time
			rem format is: x:\CAMS\ArchivedFiles\2011_08_15_00_00_00
			set bat_startdrive=!bat_arg1:~0,2!
			set bat_startlocation=!bat_startdrive!\CAMS
			set bat_mainspec=!bat_startlocation!\ArchivedFiles
			set bat_mainfilter=^|find /i "!bat_getdirname!"
		) else (
			rem look for 2011_08_15_00_00_00
			echo     Scanning like this: %~1^|find /i /c "ArchivedFiles\"
			echo     %~1|find /i /c "ArchivedFiles\"
			echo     !errorlevel!
			if !errorlevel! equ 0 (
				echo     Format: ArchivedFiles\!bat_getdirname!
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=^|find /i "!bat_getdirname!"
			) else (
				echo     Format: 2011_08_15_00_00_00
				set bat_mainspec=!bat_startlocation!\ArchivedFiles
				set bat_mainfilter=|find /i /c "!bat_getdirname!"
			)
		)
	)
	
%return%


:MENU
	cls
	if not defined bat_captureddate (
		set bat_titlebar=%~dpnx0 - CAMS MENU Vers !bat_vers!
	) else (
		set bat_titlebar=%~dpnx0 - CAMS MENU Vers !bat_vers!  for Captured Date: !bat_captureddate!
		call :FORMATDATE bat_dateinput !bat_captureddate!
	)
	TITLE !bat_titlebar!
	echo  !bat_titlebar!
	echo.
	echo  1. Choose target drive        !bat_targetdrive!
	echo  2. Enter Camera               !bat_camera!
	echo  3. Enter Captured Date        !bat_captureddate!
	echo.
	echo  4. CheckTwilight             
	echo  5. Launch Capture Script
	echo.
	echo  6. Choose CapturedFiles       !bat_capturedfilesdir!  [Files=!bat_capturedcount!]
	echo  7. Check Skipped Frames
	echo.
	echo  8. Multi-tasked Reprocess 
	echo.
	echo  9. Choose ArchivedFiles       !bat_archivedfilesdir!  [Files=!bat_archivedcount!]
	echo 10. Post MultiScan Processing
	echo 11.    MergeCaseFiles
	echo 12.    FTP_MeteorCal_Update       Latest Cal: !bat_latestcal!
	echo 13.    FTP_MeteorCal             
	echo 14.    FTP_ApplyCal2detectinfo to ArchivedFiles
	echo 15.    FTP_Confirmation
	echo 16.       Edit comments.txt file
	echo 16a.      FTP_ApplyCal2detectinfo to ConfirmedFiles
	echo 17.    Submission
	echo 18.       Choose Submission dir   !bat_submissionfilesdir!
	echo 19.       Undo from Submission 
	echo 20. Make Transmit Zip       !bat_zipfile!
	echo 21. Upload Zip via FTP
	echo 22. Email notice
	echo.
	echo  U. Utility Menu
	
	echo.
	
	set bat_choice=none
	set /P bat_choice=Enter choice or [R]eset or [Q]uit: 
	echo.
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" equ "r" (
		set bat_captureddate=
		set bat_capturedfilesdir=
		set bat_archivedfilesdir=
		set bat_archdirname=
		set bat_archivedate=
		set bat_archivedcount=
		set bat_submissionfilesdir=
		set bat_submissiondirname=
		set bat_submissiondate=
		call :SAVECONFIG
	)
	
	if /i "!bat_choice!" equ "1"  call :CHOOSETARGETDRIVE&goto :MENU
	if /i "!bat_choice!" equ "2"  call :ENTERCAMERA&goto :MENU
	if /i "!bat_choice!" equ "3"  call :CHOOSEDATE
	if /i "!bat_choice!" equ "4"  call :GETTWILIGHT&GOTO :MENU
	if /i "!bat_choice!" equ "5"  call :LAUNCHCAPTURE&GOTO :MENU
	if /i "!bat_choice!" equ "6"  call :CHOOSECAP&goto :MENU
	if /i "!bat_choice!" equ "7"  call :SKIPPEDFRAMES&GOTO :MENU
	if /i "!bat_choice!" equ "8"  call :REPROCESSMULTI&goto :MENU
	if /i "!bat_choice!" equ "9"  call :CHOOSEARCH&goto :MENU
	if /i "!bat_choice!" equ "10" call :POSTMULTI&goto :MENU
	if /i "!bat_choice!" equ "11" call :MERGECASE&goto :MENU
	if /i "!bat_choice!" equ "12" call :CALUPDATE&goto :MENU
	if /i "!bat_choice!" equ "13" call :CAL&goto :MENU
	if /i "!bat_choice!" equ "14" call :APPLY&goto :MENU
	if /i "!bat_choice!" equ "15" call :CONFIRM&goto :MENU
	if /i "!bat_choice!" equ "16" call :EDITCOMMENTS&goto :MENU
	if /i "!bat_choice!" equ "16a" call :APPLYCONFIRMED&goto :MENU
	if /i "!bat_choice!" equ "17" call :SUBMIT&goto :MENU
	if /i "!bat_choice!" equ "18" call :choosesubmission&goto :MENU
	if /i "!bat_choice!" equ "19" call :RESTORESUBMIT&goto :MENU
	if /i "!bat_choice!" equ "20" call :MAKEZIP&goto :MENU
	if /i "!bat_choice!" equ "21" call :UPLOADFTP&goto :MENU
	if /i "!bat_choice!" equ "22" call :EMAILTEXT&goto :MENU
	
	
	if /i "!bat_choice!" equ "u" goto :UTILSMENU
	
goto :MENU


:UTILSMENU
	cls
	if not defined bat_captureddate (
		set bat_titlebar=CAMS MENU Vers !bat_vers!
	) else (
		set bat_titlebar=CAMS MENU Vers !bat_vers!  for Captured Date: !bat_captureddate!
	)
	TITLE !bat_titlebar!
	echo  !bat_titlebar!
	echo  1. Command Prompt                   [ !bat_targetdrive!\CAMS^> ]
	echo  2. CheckBinFileSize
	echo  3. CheckBinFileSize.cleanup.bat
	echo  4. CheckFreeSpace.bat
	echo  5. ListDrives.bat
	echo  6. ValidateCal.bat
	echo  7. Meteor Count.bat                 [ presubmission ]
	echo  8. Meteor Count.bat                 [ submission ]
	echo  9. GetFFDirectoryListing.bat
	echo 10. GetCaptured.bat
	echo 11. GetArchived.bat
	echo 12. DayOfWeek
	echo 13. Save Configuration ["%~dpnx0.ini"]
	

	set bat_choice=none
	set /P bat_choice=Enter choice or [M]enu or [Q]uit: 
	echo.
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" equ "m" goto :MENU
	
	if /i "!bat_choice!" equ "1" call :CMDPROMPT&goto :UTILSMENU
	if /i "!bat_choice!" equ "2" call :CHECKBINFILESIZE&goto :UTILSMENU
	if /i "!bat_choice!" equ "3" call :CHECKBINCLEANUP&goto :UTILSMENU
	if /i "!bat_choice!" equ "4" call :CHECKFREESPACE&goto :UTILSMENU
	if /i "!bat_choice!" equ "5" call :LISTDRIVES&goto :UTILSMENU
	if /i "!bat_choice!" equ "6" call :VALIDATECAL&goto :UTILSMENU
	if /i "!bat_choice!" equ "7" call :METEORCOUNTPRE&goto :UTILSMENU
	if /i "!bat_choice!" equ "8" call :METEORCOUNTSUB&goto :UTILSMENU
	if /i "!bat_choice!" equ "9" call :GETFFDIRLIST&goto :UTILSMENU
	if /i "!bat_choice!" equ "10" call :GETCAPTURED&goto :UTILSMENU
	if /i "!bat_choice!" equ "11" call :GETARCHIVED&goto :UTILSMENU
	if /i "!bat_choice!" equ "12" call :DAYOFWEEK&goto :UTILSMENU
	if /i "!bat_choice!" equ "13" call :SAVECONFIG&goto :UTILSMENU
	if /i "!bat_choice!" equ "?" set bat_&pause&goto :UTILSMENU
	
goto :UTILSMENU


REM ======================= MAIN MENU ===================================
:CHOOSETARGETDRIVE
	call ListDrives.bat
	echo.
	echo.
	set bat_choice=
	set /P bat_choice=Enter drive [!bat_targetdrive!]: 
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_targetdrive!)
	set bat_choice=!bat_choice::=!
	set bat_choice=!bat_choice!:

	set bat_targetdrive=!bat_choice!
	
	call :SAVECONFIG
%bat_return%
	

:ENTERCAMERA
	set /p bat_camera=Enter Camera number: 
	call :SAVECONFIG

%bat_return%


:CHOOSECAP
	echo.
	set /a bat_counter=0

	set bat_finddate=
	if "!bat_captureddate!" neq "" (
		set bat_finddate=^|find /i "!bat_captureddate!"
	)

	echo    Listing of CapturedFiles:
	echo.
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdrive!\CAMS\CapturedFiles" /s/b /ad /on!bat_finddate!`) do (
		set /a bat_counter+=1
		echo      !bat_counter!. %%a
	)
	echo.
	
	if !bat_counter! equ 0 (
		set /P bat_choice=No CapturedFiles directories found matching !bat_captureddate!
		%bat_return%
	)
	set bat_choice=
	set /P bat_choice=Select the CapturedFiles directory to work with: 
	if "!bat_choice!" equ "" %bat_return%

	set /a bat_capturedcount=0
	set /a bat_archivedcount=0
	set /a bat_counter=0
	set bat_found=false
	set bat_dirname= 

	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdrive!\CAMS\CapturedFiles" /s/b /ad /on!bat_finddate!`) do (
		set /a bat_counter+=1
		if "!bat_counter!" equ "!bat_choice!" (
			set bat_capturedfilesdir=%%~a
			set bat_found=true
			set bat_dirname=%%~nxa
			set bat_capdirname=%%~nxa
		)
	)
	if /i !bat_found! equ false goto :CHOOSECAP

	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"


	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
	)
	
	rem set bat_captureddate=
	set bat_archivedfilesdir=
	set bat_archdirname=
	set bat_archivedate=
	set bat_submissiondirname=
	set bat_submissiondate=

	call :GETCAMERAFROMCAPTURED
	call :SAVECONFIG
%bat_return%


:GETCAMERAFROMCAPTURED
	for /f "usebackq tokens=*" %%a in (`dir "!bat_capturedfilesdir!\FF???_*.bin" /s/b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%


:CHOOSEARCH
	echo.
	set /a bat_counter=0

	set bat_finddate=

	if "!bat_captureddate!" neq "" (
		set bat_finddate=^|find /i "!bat_captureddate!"
	)


	echo    Listing of ArchivedFiles:
	echo.
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdrive!\CAMS\ArchivedFiles" /s/b /ad /on!bat_finddate!`) do (
		set /a bat_counter+=1
		echo      !bat_counter!. %%a
	)
	echo.

	if !bat_counter! equ 0 (
		set /P bat_choice=No ArchivedFiles directories found matching !bat_captureddate!
		%bat_return%
	)
	set bat_choice=
	set /P bat_choice=Select the ArchivedFiles directory to work with: 
	if "!bat_choice!" equ "" %bat_return%

	set /a bat_counter=0
	set bat_found=false
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdrive!\CAMS\ArchivedFiles" /s/b /ad /on!bat_finddate!`) do (
		set /a bat_counter+=1
		if "!bat_counter!" equ "!bat_choice!" (
			set bat_archivedfilesdir=%%a
			set bat_found=true
			set bat_dirname=%%~nxa
			set bat_archdirname=%%~nxa
			set bat_archiveddate=!bat_dirname:~0,10!
		)
	)
	if /i !bat_found! equ false goto :CHOOSEARCH
	
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"

	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
	)
	call :GETCAMERAFROMARCHIVED
	call :SAVECONFIG

%bat_return%


:GETCAMERAFROMARCHIVED
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FF???_*.bin" /s/b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%


:CHOOSESUBMISSION
	echo.

	echo bat_captureddate="!bat_captureddate!"
	if /i "!bat_captureddate!" equ "" (
		call :CHOOSEDATE
		goto :CHOOSESUBMISSION
	)


	set bat_finddate=

	if "!bat_captureddate!" neq "" (
		set bat_finddate=%^ ^|find /i "!bat_captureddate!"
	)


	set /a bat_counter=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetdrive!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdrive!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`) do (
		set /a bat_counter+=1
		echo !bat_counter!. %%a
	)
	echo.

	if !bat_counter! equ 0 (
		set /P bat_choice=No SubmissionFiles directories found matching !bat_captureddate!
		%bat_return%
	)
	set bat_choice=
	set /P bat_choice=Select the SubmissionFiles directory to work with: 
	if "!bat_choice!" equ "" %bat_return%

	set /a bat_counter=0
	set bat_found=false
	echo Listing of SubmissionFiles:
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdrive!\CAMS\SubmissionFiles" /b /ad /on!bat_finddate!`) do (
		set /a bat_counter+=1
		if "!bat_counter!" equ "!bat_choice!" (
			set bat_submissionfilesdir=!bat_targetdrive!\CAMS\SubmissionFiles\%%a
			set bat_found=true
			set bat_dirname=%%~nxa
			set bat_submissiondirname=%%~nxa
			set bat_Submissiondate=!bat_dirname:~0,10!
		)
	)
	if /i !bat_found! equ false goto :CHOOSEARCH
	
	
	if not defined bat_captureddate (
		set bat_captureddate=!bat_dirname:~0,10!
	)

:CHOOSESUBMISSION2
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /b /ad`) do (
		set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
		set bat_capdirname=%%a
		set bat_captureddate=!bat_capdirname:~0,10!
	)
	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	
	
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles" /b /ad`) do (
		set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
		set bat_archdirname=%%a
		set bat_archiveddate=!bat_archdirname:~0,10!
	)
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"

	call :GETCAMERAFROMSUBMISSION
pause
%bat_return%


:GETFILECOUNT [out] bat_capturedcount [in] "dir"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		set %1=%%a
	)
%bat_return%

:GETCAMERAFROMSUBMISSION
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\FF???_*.bin" /s/b /a-d`) do (
		set bat_temp=%%~nxa
		set bat_camera=!bat_temp:~2,3!
	)
%bat_return%



:CHOOSEDATE
	echo.
	echo   Here is a list of CaptureFiles directories:
	echo.
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdrive!\CAMS\CapturedFiles" /s/b /ad /on`) do (
		set bat_temp=%%~nxa
		set bat_temp=!bat_temp:~5,2!/!bat_temp:~8,2!/!bat_temp:~0,4!
		echo     !bat_temp!   %%~nxa
	)
	echo.
	set bat_choice=
	set /P bat_choice=Enter the date for processing [mm/dd/yyyy]: 
	echo "!bat_choice!"
	if /i "!bat_choice!" equ "" (
		echo "!bat_choice!"
		pause
		%bat_return%
	)
	
	for /f "delims=/ tokens=1-3" %%a in ("!bat_choice!") do (
		set bat_yyyy=20%%c
		set bat_yyyy=!bat_yyyy:~-4!
		set bat_mm=0%%a
		set bat_mm=!bat_mm:~-2!
		set bat_dd=0%%b
		set bat_dd=!bat_dd:~-2!
		
	)
	set bat_captureddate=!bat_yyyy!_!bat_mm!_!bat_dd!
	set bat_capturedfilesdir=
	set bat_archivedfilesdir=
	set bat_latestcal=
	set /a bat_capturedcount=0
	set /a bat_archivedcount=0
	call :SAVECONFIG
	pause
%bat_return%

:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%


:GETTWILIGHT
	rem get twilight for today or the CapturedFiles date
	set bat_twilightdate=
	if defined bat_captureddate (
		set bat_twilightdate=!bat_dateinput!
	)
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\CheckTwilight.bat !bat_twilightdate!
	     call !bat_exedir!\CheckTwilight.bat !bat_twilightdate!
	echo.
	cd /d !bat_exedir!
	pause
%bat_return%


:CHOOSECAMERA
	if not exist "!bat_targetdrive!\CAMS\Cal\CameraSites.txt" (
		echo ERROR - Not Found: "!bat_targetdrive!\CAMS\Cal\CameraSites.txt"
	)
	set bat_choice=
	set /P bat_choice=Enter your camera number: 
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_camera!)
	if "!bat_choice!" equ "" %bat_return%
	
	set bat_temp=!bat_choice!      
	set bat_temp=!bat_temp:~0,6!
	
	find /i "!bat_temp!!bat_camerahint!" "!bat_targetdrive!\CAMS\Cal\CameraSites.txt"
	if !errorlevel! neq 0 (
		echo ERROR - Camera Not Found: !bat_choice! in "!bat_targetdrive!\CAMS\Cal\CameraSites.txt"
	)

	set bat_choice=
	set /P bat_choice2=Do you see your camera in this list? Y/N 
	if /i "!bat_choice2!" neq "y" goto :CHOOSECAMERA

	set bat_camera=!bat_choice!
	call :SAVECONFIG
%bat_return%



:CHOOSESTATION
	set bat_temp= 
	set /a bat_counter=0
	for /f "usebackq tokens=1-7 skip=2" %%a in (`type "!bat_targetdrive!\CAMS\Cal\CameraSites.txt"^|sort /+63`) do (
		if /i "%%a" equ "Cam#" goto :CHOOSESTATION2
		if /i "%%a" equ "----" goto :CHOOSESTATION2
		if /i "%%f" equ "!bat_temp!" goto :CHOOSESTATION2
		if "!bat_temp!" neq "!bat_siteabbrev!" (
			set bat_counter+=1
			set bat_siteabbrev=%%f
			set bat_temp=!bat_siteabbrev!
			echo %%f  %%g
		)
		
:CHOOSESTATION2		
	)
	
	set bat_choice=
	set /P bat_choice=Enter your site abbreviation (2 characters): 
	
	set bat_temp= 
	set /a bat_counter=0
	for /f "usebackq tokens=1-7 skip=2" %%a in (`type "!bat_targetdrive!\CAMS\Cal\CameraSites.txt"^|sort /+63`) do (
		if /i "%%a" equ "Cam#" goto :CHOOSESTATION2
		if /i "%%a" equ "----" goto :CHOOSESTATION2
		if /i "%%f" equ "!bat_choice!" (
			set bat_counter+=1
			echo %%a  %%b  %%c  %%d  %%e  %%f  %%g
		)
	)
	
	set bat_choice=
	set /P bat_choice=Enter your camera number: 
	set bat_camera=!bat_choice!
%bat_return%




:LAUNCHCAPTURE
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	echo.
	echo WARNING - This routine will start the capture process and it will kill
	echo           any existing running capture instances.  If capture
	echo           has already happened for this date and you don't want to
	echo           start it again, [Q]uit now.  Otherwise, [C]ontinue: 
:LAUNCHCAPTURE2
	set /p bat_choice=
	if /i "!bat_choice!" equ "q" %bat_return%
	if /i "!bat_choice!" neq "c" goto :LAUNCHCAPTURE2

	if not defined bat_targetdrive (
		call :CHOOSETARGETDRIVE
	)
	
	if not defined bat_camera (
		call :CHOOSECAMERA
	)
	
	cd /d !bat_targetdrive!\CAMS
	start "LaunchCapture !bat_camera! 1 !bat_targetdrive!\" LaunchCapture !bat_camera! 1 !bat_targetdrive!\
	cd /d !bat_exedir!
	pause
%bat_return%


:SKIPPEDFRAMES
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\skippedFrames.bat "!bat_capturedfilesdir!" /v
	     call !bat_exedir!\SkippedFrames.bat "!bat_capturedfilesdir!" /v

	cd /d !bat_exedir!
	pause
	
%bat_return%


:REPROCESSMULTI
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	
	echo.
	echo WARNING - This routine will start the meteor scan.  It will 
	echo           delete the collection of "ftpdetectinfo.txt" like 
	echo           files that may have already been created in the 
	echo           ArchivedFiles directory from a previous run.  If 
	echo           you do NOT wish to delete and overwrite those files, 
	echo.
:REPROCESSMULTI2
	set bat_choice=
	set /p bat_choice=[Q]uit now, otherwise, [C]ontinue: 
	if /i "!bat_choice!" equ "q" %bat_return%
	if /i "!bat_choice!" neq "c" goto :REPROCESSMULTI2
	
	echo.
	set /p 

	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\makeCaseListing.bat "!bat_capturedfilesdir!"
	     call !bat_exedir!\makeCaseListing.bat "!bat_capturedfilesdir!"
	cd /d !bat_exedir!
	pause
%bat_return%

:CAL
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	
	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	pause
	echo.
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\FTP_MeteorCal.exe
	     call !bat_exedir!\FTP_MeteorCal.exe
	cd /d !bat_exedir!
	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	pause
	echo.
%bat_return%


:CALUPDATE
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	
	echo.
	echo Typically, you would calibrate using the ArchivedFiles dir, however,
	echo there may be times when the Meteor Count is zero and you'd need to 
	echo calibrate using the CapturedFiles dir.  However, it might not make
	echo sense to even do that since there won't be anything to submit when
	echo the Meteor Count is zero.
	
	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	pause
	echo.
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\FTP_MeteorCal_Update.exe
	     call !bat_exedir!\FTP_MeteorCal_Update.exe 
	cd /d !bat_exedir!
	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	pause
	echo.
%bat_return%


:POSTMULTI
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		%bat_return%
	)
	
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\PostMultiScanCalibration.bat "!bat_archivedfilesdir!"
	     call !bat_exedir!\PostMultiScanCalibration.bat "!bat_archivedfilesdir!"
	cd /d !bat_exedir!
	set bat_hasrun_post=true
	pause
%bat_return%


:MERGECASE
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		%bat_return%
	)
	
	call MergeCaseFiles.bat "!bat_archivedfilesdir!"
	
	rem Get latest cal file
	set bat_latestcal=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestcal ( set bat_latestcal=%%a )
	)


	pause
%bat_return%


:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "%%a"
		echo     call WaitForFile rw "%%a"
		         call WaitForFile rw "%%a"
	)
	echo.
%bat_return%


:CONFIRM
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		%bat_return%
	)
	
	cd /d !bat_targetdrive!\CAMS
	echo start !bat_exedir!\FTP_Confirmation.exe
	     start !bat_exedir!\FTP_Confirmation.exe 
	cd /d !bat_exedir!
	pause
%bat_return%




:EDITCOMMENTS
	cd /d "!bat_targetdrive!\CAMS"
	echo start notepad "!bat_targetdrive!\CAMS\ConfirmedFiles\!bat_archdirname!\comments.txt"
	     start notepad "!bat_targetdrive!\CAMS\ConfirmedFiles\!bat_archdirname!\comments.txt"
	cd /d !bat_exedir!
%bat_return%



:APPLY
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	
	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		%bat_return%
	)
	
	cd /d !bat_targetdrive!\CAMS
	echo call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	cd /d !bat_exedir!

	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestcal ( set bat_latestcal=%%a )
	)


	pause
%bat_return%


:APPLYCONFIRMED
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		%bat_return%
	)
	
	set bat_archivedfilesdir	
	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!
	
	cd /d !bat_targetdrive!\CAMS
	echo call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!"
	     call "!bat_exedir!\ApplyCal.bat" "!bat_confirmedfilesdir!"
	cd /d !bat_exedir!

	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_confirmedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestconfcal ( set bat_latestconfcal=%%a )
	)


	pause
%bat_return%


:SUBMIT
	if /i "!bat_submissionfilesdir!" neq "" (
		echo.
		set /p bat_choice=You probably don't want to do this - you have already run Submission: 
		%bat_return%
	)
	
	if /i "!bat_captureddate!" equ "" (
		call :CHOOSEDATE
		goto :SUBMIT
	)

	if /i "!bat_archivedfilesdir!" equ "" (
		echo.
		set /p bat_choice=You need to Choose ArchivedFiles first: 
		%bat_return%
	)
	

	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\submission2.bat !bat_archdirname!
	     call !bat_exedir!\submission2.bat !bat_archdirname!
	cd /d !bat_exedir!
	
	set bat_submissionfilesdir=!bat_targetdrive!\CAMS\SubmissionFiles\!bat_captureddate!
	set bat_submissiondirname=!bat_archdirname!
	set bat_submissiondate=!bat_captureddate!

	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\!bat_captureddate!*" /b /ad`) do (
		set bat_capturedfilesdir=!bat_submissionfilesdir!\!bat_camera!\CapturedFiles\%%a
		set bat_capdirname=%%a
		set bat_captureddate=!bat_capdirname:~0,10!
	)
	call :GETFILECOUNT bat_capturedcount "!bat_capturedfilesdir!"
	
	
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\!bat_captureddate!*" /b /ad`) do (
		set bat_archivedfilesdir=!bat_submissionfilesdir!\!bat_camera!\ArchivedFiles\%%a
		set bat_archdirname=%%a
		set bat_archiveddate=!bat_archdirname:~0,10!
	)
	call :GETFILECOUNT bat_archivedcount "!bat_archivedfilesdir!"



	pause
%bat_return%


	rem Restore the Archived, Captured, and Confirmed files from 
	rem the SubmissionFiles directory to the basic CAMS subdirs
:RESTORESUBMIT
	cd /d !bat_targetdrive!\CAMS
	call :SEARCHFORDIR "!bat_targetdrive!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ArchivedFiles\!bat_captureddate!*"
	set bat_archivedfilesdir=!bat_targetdrive!\CAMS\ArchivedFiles\!bat_retval3!
	set bat_archdirname=!bat_retval3!	
	echo move /y "!bat_retval!" "!bat_targetdrive!\CAMS\ArchivedFiles"
	     move /y "!bat_retval!" "!bat_targetdrive!\CAMS\ArchivedFiles"
	
	     
	call :SEARCHFORDIR "!bat_targetdrive!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\CapturedFiles\!bat_captureddate!*"
	set bat_capturedfilesdir=!bat_targetdrive!\CAMS\CapturedFiles\!bat_retval3!
	set bat_capdirname=!bat_retval3!	
	echo move /y "!bat_retval!" "!bat_targetdrive!\CAMS\CapturedFiles"
	     move /y "!bat_retval!" "!bat_targetdrive!\CAMS\CapturedFiles"
	     
	call :SEARCHFORDIR "!bat_targetdrive!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\ConfirmedFiles\!bat_captureddate!*"
	set bat_confirmedfilesdir=!bat_targetdrive!\CAMS\ConfirmedFiles\!bat_retval3!
	set bat_confdirname=!bat_retval3!	
	echo move /y "!bat_retval!" "!bat_targetdrive!\CAMS\ConfirmedFiles"
	     move /y "!bat_retval!" "!bat_targetdrive!\CAMS\ConfirmedFiles"
	cd /d !bat_exedir!
	
	set bat_submissionfilesdir=
	set bat_submissiondirname=
	set bat_submissiondate=
	
	pause
%bat_return%


:SEARCHFORDIR [out] bat_retval [out] bat_retval2[in]  [out] bat_retval3 bat_basedir
	rem bat_retval	is a fully qualified directory name
	rem bat_retval2 is that path not including the last directory name of the path
	rem bat_retval3 is the last directory name in the path
	
	echo :SEARCHFORDIR "%~1" 
	set bat_retval= 
	for /f "usebackq tokens=*" %%a in (`dir "%~1" /s/b /ad`) do (
		set bat_retval=%%a
		set bat_retval2=%%~dpa::
		set bat_retval2=!bat_retval2:\::=!
		set bat_retval2=!bat_retval2:::=!
		set bat_retval3=%%~nxa
	)
	set bat_retval
%bat_return%


:MAKEZIP
	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		set /p bat_choice=Run Submission before zipping: 
		%bat_return%
	)
	
	rem This requires wzcline
	if not defined bat_camera (
		echo ERROR - Please enter camera number
		%bat_return%
	)
	
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	if defined ProgramFiles(x86) (
		set bat_wzzip=!ProgramFiles^(x86^)!\Winzip\wzzip.exe
	) else (
		set bat_wzzip=!ProgramFiles!\Winzip\wzzip.exe
	)
	
	
	set bat_wzzip_args=-p -ybc -a "!bat_targetdrive!\CAMS\Submitted\!bat_tempdir!.zip" -r "!bat_targetdrive!\CAMS\Submitted\!bat_tempdir!"
	
	cd /d !bat_targetdrive!\CAMS
	
	set bat_
	echo call "!bat_wzzip!" !bat_wzzip_args!
	     call "!bat_wzzip!" !bat_wzzip_args!
	cd /d !bat_exedir!
	pause
%bat_return%


:UPLOADFTP
	if /i "!bat_submissionfilesdir!" equ "" (
		echo.
		set /p bat_choice=Run Submission before zipping: 
		%bat_return%
	)
	
	set bat_choice=
	set /P bat_choice=Enter your email address as the anonymous FTP password: 
	set bat_email=!bat_choice!

	cd /d !bat_targetdrive!\CAMS
	
	set bat_ftpfile=ftp.temp.txt
	
	echo user anonymous>"!bat_ftpfile!"
	echo !bat_email!>>"!bat_ftpfile!"
	echo bin>>"!bat_ftpfile!"
	echo cd incoming>>"!bat_ftpfile!"
	echo put "!bat_targetdrive!\CAMS\Submitted\!bat_captureddate!_!bat_camera!.zip">>"!bat_ftpfile!"
	echo quit>>"!bat_ftpfile!"
	
	echo call ftp -n -s:"ftp.temp.txt" ftp.seti.org
	     call ftp -n -s:"ftp.temp.txt" ftp.seti.org
	set bat_retval=!errorlevel!
	echo !bat_retval!
	
	cd /d !bat_exedir!
	echo.
	pause
%bat_return%


:EMAILTEXT
	set bat_tempdir=!bat_captureddate!_!bat_camera!
	echo.
	echo Email the following text to your central coordinator:
	echo.
	echo     Subject: CAMS submission for Camera !bat_camera! for !bat_captureddate!
	echo.
	echo     The CAMS submission for camera !bat_camera! for !bat_captureddate! has been uploaded 
	echo     to the FTP server.  The file name is:
	echo        "!bat_tempdir!.zip"
	echo.
	echo.
	echo     Please let me know if anything of significance was found using this data.
	echo.
	set bat_emailfilesdir=!bat_targetdrive!\CAMS\SubmissionFiles\!bat_captureddate!\!bat_camera!\EmailFiles
	for /f "usebackq tokens=*" %%h in (`dir "!bat_emailfilesdir!\arch*.txt" /s/b`) do (
		for /f "tokens=1-6 delims=.,=" %%i in ("%%h") do (
			echo                     Archived    Confirmed
			echo     Meteor Count    %%j          %%l
		)
	)

	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt" /s/b /od /a-d`) do (
		set bat_calfilename=%%h
	)

	for /f "usebackq tokens=1-9 delims==" %%h in (`type "!bat_submissionfilesdir!\!bat_camera!\Cal\CAL!bat_camera!_*.txt"`) do (
		set bat_found=0
		if "%%h" equ " Camera number            " (set bat_found=1)
		if "%%h" equ " Calibration date         " (set bat_found=1)
		if "%%h" equ " Calibration time (UT)    " (set bat_found=1)
		if "%%h" equ " Cal center Azim (deg)    " (set bat_found=1)
		if "%%h" equ " Cal center Elev (deg)    " (set bat_found=1)
		if "%%h" equ " Cam tilt wrt Horiz (deg) " (set bat_found=1)
		if "%%h" equ " Mean O-C " (set bat_found=1)
		if !bat_found! equ 1 (
			echo  %%h =%%i
		)
	)
	set /a bat_calfilestars=0
	for /f "usebackq tokens=1-3" %%h in (`find /i /c " " "!bat_calfilename!"`) do (
		
		set /a "bat_calfilestars=%%j-56"
	)
	echo   Cal stars used: !bat_calfilestars!

	echo.
	for /f "usebackq tokens=*" %%h in (`dir "!bat_submissionfilesdir!\!bat_camera!\CapturedFiles" /s/b /ad`) do (
		echo call !bat_exedir!\skippedFrames.bat "%%h"
			 call !bat_exedir!\skippedFrames.bat "%%h"
	)
	
	     
	     
	pause
%bat_return%
goto :EOF


:GETCALFILEINFO
	call GetCalfileInfo.bat "!bat_calfilename!"
%bat_return%



:CHECKBINFILESIZE
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	     call !bat_exedir!\CheckBinFileSize.bat "!bat_capturedfilesdir!"
	cd /d !bat_exedir!
	pause
%bat_return%



rem  =========================== UTILITY MENU ============================

:CMDPROMPT
	cd /d !bat_exedir!
	echo start "CAMS prompt" /d "!bat_exedir!" "!windir!\system32\cmd.exe"
	     start "CAMS prompt" /d "!bat_exedir!" "!windir!\system32\cmd.exe"
	cd /d !bat_exedir!
	pause
%bat_return%

:CHECKBINCLEANUP
	echo Warning, this script can delete ff*.bin files! 
	set bat_choice=
	set /P bat_choice=Are you sure? Y/N 
	if "!bat_choice!" equ "" %bat_return%
	if /i "bat_choice!" neq "y" %bat_return%

	echo call CheckBinFileSize.cleanup.bat
	call CheckBinFileSize.cleanup.bat
%bat_return%


:CHECKFREESPACE
	set bat_choice=
	set /P bat_choice=Enter drive [!bat_targetdrive!]: 
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_targetdrive!)
	set bat_choice=!bat_choice::=!
	set bat_choice=!bat_choice!:

	echo call CheckFreeSpace.bat !bat_choice!
	call CheckFreeSpace.bat !bat_choice!
	pause
%bat_return%


:LISTDRIVES
	echo call ListDrives.bat
	call ListDrives.bat
	pause
%bat_return%


:VALIDATECAL
	cd /d !bat_targetdrive!\CAMS
	echo call ValidateCal.bat
	call ValidateCal.bat
	cd /d !bat_exedir!
	pause
%bat_return%


:METEORCOUNTPRE
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\MeteorCount.presubmission.bat
		 call !bat_exedir!\MeteorCount.presubmission.bat
	cd /d !bat_exedir!
	
	pause
%bat_return%


:METEORCOUNTSUB
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\MeteorCount.submission.bat
		 call !bat_exedir!\MeteorCount.submission.bat
	cd /d !bat_exedir!
	pause
%bat_return%


:GETFFDIRLIST
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\GetFFDirectoryListing.bat !bat_dateinput!
	     call !bat_exedir!\GetFFDirectoryListing.bat !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%


:GETARCHIVED
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\GetArchived.bat !bat_dateinput!
	call !bat_exedir!\GetArchived.bat !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%


:GETCAPTURED
	cd /d !bat_targetdrive!\CAMS
	echo call !bat_exedir!\GetCaptured.bat !bat_dateinput!
	     call !bat_exedir!\GetCaptured.bat !bat_dateinput!
	cd /d !bat_exedir!
	pause
%bat_return%


:DAYOFWEEK
	echo call DayOfWeek.bat !bat_capturedDate!
	call DayOfWeek.bat !bat_capturedDate!
	pause
%bat_return%


:SAVECONFIG
	set bat_configfile=%~dpnx0.ini
	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetdrive=!bat_targetdrive!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=!bat_latestcal!>>"!bat_configfile!"
	echo bat_submissionfilesdir=!bat_submissionfilesdir!>>"!bat_configfile!"
%bat_return%

:READCONFIG
	set bat_configfile=%~dpnx0.ini
	for /f "usebackq tokens=*" %%x in (`type "!bat_configfile!"`) do (
		echo set %%x
		     set %%x
	)
%bat_return%


:MAIN
	echo :MAIN
	rem start the execution of the detection pass in background priority

	echo %date% %time%>"%bat_logfile%"
	set bat_>>"%bat_logfile%"
	call :GETDIRNAMES
	echo waiting 2 seconds...
	start /w wait 2
goto :DONE



:GETDIRNAMES
	echo :GETDIRNAMES [%*]
	rem Loop to iterate through all directory names under the ..\ArchivedFiles structure.
	echo     for /f "usebackq tokens=*" %%a in (`dir "!bat_mainspec!" /s/b /ad /on !bat_mainfilter! 2^>nul`) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_mainspec!" /s/b /ad /on !bat_mainfilter! 2^>nul`) do (
		echo     %%~a
		echo.

		set bat_archiveddirfull=%%a&		rem C:\CAMS\ArchivedFiles\2011_08_15_04_28_20
		set bat_dirname=%%~nxa&				rem 2011_08_15_04_28_20
		set bat_dirdate=!bat_dirname:~0,10!

		call :GETCAMERAFROMDETECT "!bat_archiveddirfull!"

		rem Note: The date/time in the CapturedFiles directory will be different
		rem       than the date/time in the ArchivedFiles directory.  This is 
		rem       because the date/time of the CapturedFiles directory is 
		rem       the date/time when the directory was created, which is
		rem       several seconds before the end of the first 8 second video
		rem       section.  The date/time of the ConfirmedFiles and ArchivedFiles
		rem       directory is the date/time of the first file in the CapturedFiles
		rem       directory.
		set bat_yyyymmdd=!bat_dirname:~0,10!&	rem 2011_08_15
		set bat_captureddir=%bat_startlocation%\CapturedFiles\!bat_yyyymmdd!&	rem C:\CAMS\CapturedFiles\2011_08_15

		set bat_submissiondir=%bat_startlocation%\SubmissionFiles\!bat_dirdate!\!bat_camera!&	rem C:\CAMS\SubmissionFiles\213\2011_08_15
		set bat_confirmeddirfull=%bat_startlocation%\ConfirmedFiles\!bat_dirname!&	rem C:\CAMS\ConfirmedFiles\2011_08_15_04_28_20
		set bat_emailfilesdir=!bat_submissiondir!\EmailFiles&						rem C:\CAMS\SuibmissionFiles\2011_08_15_04_28_20\EmailFiles
		
		set bat_submitarchived=!bat_submissiondir!\ArchivedFiles\!bat_dirname!&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\ArchivedFiles\2011_08_15_04_28_20
		set bat_submitconfirmed=!bat_submissiondir!\ConfirmedFiles\!bat_dirname!&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\ConfirmedFiles\2011_08_15_04_28_20
		set bat_submitcal=!bat_submissiondir!\Cal&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\Cal
		set bat_submitcapturedbase=!bat_submissiondir!\CapturedFiles&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\CapturedFiles

		set bat_binfilesdir=!bat_submissiondir!\ERROR1&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\BinFiles
		set bat_avifilesdir=!bat_submissiondir!\ERROR2&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\AviFiles
		
		if "!bat_dirname!" equ "" (
			echo.
			echo.
			echo     ERROR - bat_dirname="!bat_dirname!"   ArchivedFiles dir="%%a"
			echo.
			echo.
		) else (
			call :CREATEDIRS "!bat_dirname!"
			call :MOVEFILES "!bat_dirname!"
			call :READFILE

			call :COPYCALFILE "!bat_calfilename!" "!bat_camera!"

			
			call :STRIPHEADER bat_countconfirmed "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "confirmed"
			call :STRIPHEADER bat_countarchived  "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "scanned"

			call :COUNTFILE !bat_countarchived! !bat_countconfirmed!
		)

		echo.
		echo call submit.email "!bat_dirdate!"
		     call submit.email "!bat_dirdate!"
	)&	rem end of for /f %%a in (`dir "!bat_mainspec!" /s/b /ad /on !bat_mainfilter! 2^>nul`)
	
%return%


	rem usage: call :CREATEDIRS "!bat_dirname!"
:CREATEDIRS
	echo :CREATEDIRS %*
	echo     md "!bat_emailfilesdir!"
	         md "!bat_emailfilesdir!"
		     
	echo     md "!bat_emailfilesdir!\Cal-!bat_camera!"
	         md "!bat_emailfilesdir!\Cal-!bat_camera!"
		     
	echo     md "!bat_submissiondir!\ArchivedFiles"	     
	         md "!bat_submissiondir!\ArchivedFiles"	
	     
	echo     md "!bat_submissiondir!\ConfirmedFiles"	     
	         md "!bat_submissiondir!\ConfirmedFiles"	
	     
	echo     md "!bat_submitcal!"	     
	         md "!bat_submitcal!"
	     
	echo     md "!bat_submitcapturedbase!"	     
	         md "!bat_submitcapturedbase!"	     

%return%


:MOVEFILES
echo :MOVEFILES %*
	echo     copy /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
	         copy /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
	if not exist "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt" (
		echo     Failed to copy
		pause
	)

	if exist "!bat_confirmeddirfull!\comments.txt" (
		echo     copy /Y "!bat_confirmeddirfull!\comments.txt" "!bat_emailfilesdir!"
				 copy /Y "!bat_confirmeddirfull!\comments.txt" "!bat_emailfilesdir!"
		if not exist "!bat_emailfilesdir!\comments.txt" (
			echo     Failed to copy
			pause
		)
	)
		  

	echo     move /Y "!bat_confirmeddirfull!" "!bat_submitconfirmed!"
		     move /Y "!bat_confirmeddirfull!" "!bat_submitconfirmed!"
	if !errorlevel! neq 0 (
		echo     Failed to move
		pause
	)
	
	if exist "!bat_confirmeddirfull!" (
		echo     Failed to move
		pause
	)
		  
		 
    echo     copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned.txt"
             copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned.txt"
             
    echo Packaged for submission on %date% %time%^>"!bat_emailfilesdir!\submit.txt"
    echo Packaged for submission on %date% %time%>"!bat_emailfilesdir!\submit.txt"
    
    rem Can't do this one now because the dir hasn't been created yet
    rem echo Packaged for submission on %date% %time%^>"!bat_captureddir!\submit.txt"
    rem echo Packaged for submission on %date% %time%>"!bat_captureddir!\submit.txt"

    echo     copy /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"
             copy /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"


    echo     copy /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"
             copy /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"

	echo     copy /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"
	         copy /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"

	echo     copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"
	         copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"

	echo     move /Y "!bat_archiveddirfull!" "!bat_submitarchived!"
		     move /Y "!bat_archiveddirfull!" "!bat_submitarchived!"
	if exist "!bat_archiveddirfull!" (
		echo     Failed to move "!bat_confirmeddirfull!" to "!bat_submitconfirmed!"
		pause
	)
		  

	rem echo robocopy.exe "%%~dpnxb" "!bat_submitcapturedbase!\Captured\%%~nxb" /e /move
	rem  robocopy.exe "%%~dpnxb" "!bat_submitcapturedbase!\Captured\%%~nxb" /e /move
	for /f "usebackq tokens=*" %%b in (`dir "!bat_captureddir!*.*" /s/b /ad /on`) do (
		rem echo md "!bat_submitcapturedbase!\%%~nxb"
		rem      md "!bat_submitcapturedbase!\%%~nxb"
		     
		echo     move /y "%%~dpnxb" "!bat_submitcapturedbase!"
		         move /y "%%~dpnxb" "!bat_submitcapturedbase!"
		if exist "%%~dpnxb" (
			echo     Failed to move "!bat_confirmeddirfull!" to "!bat_submitconfirmed!"
			pause
		)
	)

%return%


	rem Loop to read the FTPdetectinfo.txt file.
:READFILE
echo :READFILE "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt", %*

	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	
	echo     for /f "usebackq tokens=*" %%a in ^(`type "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"`) do (
		set bat_temp=%%a
		set bat_temp=!bat_temp:~0,5!
		rem title bat_linecount=!bat_linecount! %%a
		set /a bat_linecount+=1
		if !bat_linecount! equ 1 (
			call :GETMETEORCOUNT bat_countconfirmed %%a
		) else (
			if !bat_linecount! equ 5 (
				call :GETFFDIR "%%a"
			) else (
				if !bat_linecount! equ 6 (
					rem call :GETCALDIR "%%a"
				) else (
					if !bat_linecount! equ 13 (
						call :GETCAMERA
						set bat_fffilename=%%a
						title !bat_fffilename!
					) else (
						if !bat_linecount! equ 14 (
							call :GETCALNAME "%%a"
						) else (
							if "!bat_temp!" equ "FF!bat_camera!" (
								set bat_fffilename=%%a
								title working on FF file: "!bat_fffilename!"
								set /a bat_filecount+=1
							)
						)
					)
				)
			)
		)
	)
%return%



:GETMETEORCOUNT
	rem Usage: call :GETMETEORCOUNT {return variable name} Meteor Count = 000533
	
	set bat_temp=%4
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	rem Strip leading zeros
	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set %1=%%a)
	if not defined %1 set %1=0
echo :GETMETEORCOUNT %* [!%1!]
%return%	


:GETEVENTCOUNT [in]detectfile [out]bat_retval
	set bat_tempfile=%~1
	set bat_retval=0

	if exist "!bat_tempfile!" (
		set /a bat_countdashes=0
	echo        for /f "usebackq tokens=3" %%X in ^(`find /i /c  ".bin" "!bat_tempfile!"`^) ...
		for /f "usebackq tokens=3" %%X in  (`find /i /c  ".bin" "!bat_tempfile!"` ) do (
			if "%%X" neq "" (
				set /a bat_countdashes=%%X
				title !bat_countdashes!
			)
		)

		set bat_countdashes=000000!bat_countdashes!
		set bat_countdashes=!bat_countdashes:~-6!
		echo     Meteor Count = !bat_countdashes!
		title Meteor Count = !bat_countdashes!  "!bat_tempfile!" 
		set bat_retval=bat_countdashes
	) else (
		echo     File not found - "!bat_tempfile!"
	)
%return%


:STRIPHEADER
echo :STRIPHEADER %*
	rem Usage: call STRIPHEADER bat_variable sourcefile targetfile
	rem Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to 
	rem "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[bat_camera]-[meteor count].txt" 
	rem with the header stripped from it.
	
	echo     Stripping header to: "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
	
	set bat_sourcefile=%~5
	
	set /a bat_countscan=0
	set /a bat_countevent=0
	
	set /a bat_remain=0
	TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d

	call :GETEVENTCOUNT "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"

	echo     for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"`)
	echo     This step may take along time, please be patient...
	for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"`) do (
		set bat_linebuf=%%d
		set /a bat_countscan+=1
		if "!bat_countscan!" equ "1" (
			call :GETMETEORCOUNT  %1 %%~d
			if exist "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt" (
				del "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
			)
			TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
		) else (
			if !bat_countscan! GTR 11 (
				echo %%d>>"!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
				if /i "!bat_linebuf:~0,6!" equ "FF!bat_camera!_" (
					set /a bat_countevent+=1
					set /a bat_remain=!%1!-!bat_countevent!
					TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
				)
			)
		)
	)
	
%return%


:GETFFDIR
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
echo :GETFFDIR %*  [!bat_ffdir!]
%return%


:GETCALDIR
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_caldir=!bat_temp2:C:=%bat_startdrive%!
	)
echo :GETCALDIR %*  [!bat_caldir!]
%return%


:GETCALNAME
	rem 
	set bat_calfilename=%~1
echo :GETCALNAME %*  [!bat_calfilename!]
%return%


:COPYCALFILE
echo :COPYCALFILE %*
	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!" (
		echo     md "!bat_emailfilesdir!\Cal-!bat_camera!"
			     md "!bat_emailfilesdir!\Cal-!bat_camera!"
	)

	echo     copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!\Cal-!bat_camera!"
	         copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!\Cal-!bat_camera!"

	echo     copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_submitcal!"
	         copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_submitcal!"
	
	echo     copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_submitcal!"
	         copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_submitcal!"

	echo     copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_emailfilesdir!\Cal-!bat_camera!"
	         copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_emailfilesdir!\Cal-!bat_camera!"

	echo     copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_submitcal!"
	         copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_submitcal!"

	call :COPYCALFF "!bat_calfilename!"

%return%

:GETCAMERA
	set bat_camera=!bat_temp:~2,3!
echo :GETCAMERA %*  [!bat_camera!]
%return%



:COUNTFILE
	echo :COUNTFILE %1 %2
	rem Create a file that has the meteorcounts
	set bat_countfile=!bat_emailfilesdir!\archived=%1, confirmed=%2.txt

	echo     Meteor Counts:  Archived="%1"   Confirmed="%2"
	echo     Meteor Counts:  Archived="%1"   Confirmed="%2">"!bat_countfile!"

	echo     copy /y /b "!bat_countfile!" + "!bat_emailfilesdir!\comments.txt" "!bat_countfile!"
	         copy /y /b "!bat_countfile!" + "!bat_emailfilesdir!\comments.txt" "!bat_countfile!"
	
	echo.>>"!bat_countfile!"

echo aaaaaaaaaaa>>"!bat_countfile!"
echo "!bat_countfile!"
	type "!bat_countfile!"
	echo     call "%~dp0CheckTwilight.bat" !bat_dirname:~5,2!/!bat_dirname:~8,2!/!bat_dirname:~0,4!^>^>"!bat_countfile!"
	         call "%~dp0CheckTwilight.bat" !bat_dirname:~5,2!/!bat_dirname:~8,2!/!bat_dirname:~0,4!>>"!bat_countfile!"
echo bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb
%return%

echo aaaaaaaaaaa>>"!bat_countfile!"


echo "!bat_countfile!"
	type "!bat_countfile!"
%return%


	rem read the cal file and use the date on line 2 and the time on 
	rem line 3 to create a search for the cal file.  To use the following
	rem example, the search will search in reverse order for the ff*.bin
	rem files from the CapturedFiles directory.
	rem Here is the format of the cal file
1	 Camera number            = 213
2	 Calibration date         = 08/18/2011
3	 Calibration time (UT)    = 03:38:09.187
:COPYCALFF
	echo :COPYCALFF %*

	set /a bat_calff_line=0
	rem if not exist "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!" ^(
	rem 	echo File Not Found: "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"
	rem 	pause
	rem ^)

	echo     for /f "usebackq skip=2 tokens=1-5" %%f in ^(`find /i "Calibration " "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"`^) do ...
	for /f "usebackq skip=2 tokens=1-5" %%f in (`find /i "Calibration " "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"`) do (
		set /a bat_calff_line+=1
		title working on FF file [!bat_calff_line!]: "!bat_fffilename!" %%f %%g %%h %%i %%j
		if !bat_calff_line! equ 1 (
			rem date
			rem echo %%f, %%g, %%h, %%i, %%j
			set bat_calffdate=%%i
			set bat_calffyyyy=!bat_calffdate:~-4!
			set bat_calffmm=!bat_calffdate:~0,2!
			set bat_calffdd=!bat_calffdate:~3,2!
		) else (
			if !bat_calff_line! equ 2 (
				rem time
				rem echo %%f, %%g, %%h, %%i, %%j
				set bat_calfftime=%%j
				set bat_calffhh=!bat_calfftime:~0,2!
				set bat_calffm=!bat_calfftime:~3,2!
				set bat_calffss=!bat_calfftime:~6,2!
			) else (
				rem ignore 
			)
		)
	)


	set bat_filespec=!bat_calffhh!!bat_calffm!!bat_calffss!
	set bat_searchspec=FF!bat_camera!_!bat_calffyyyy!!bat_calffmm!!bat_calffdd!_
	
	set bat_calff_found=0
    echo     for /f "usebackq tokens=*" %%f in ^(`dir !bat_submitcapturedbase!\!bat_searchspec!*.* /s/b /o-n`^) do 
	for /f "usebackq tokens=*" %%f in (`dir "!bat_submitcapturedbase!\!bat_searchspec!*.*" /s/b /o-n`) do (
		rem
		set bat_tempfilefull=%%f
		set bat_tempfilename=%%~nxf
		set bat_tempyyyy=!bat_tempfilename:~6,4!
		set bat_tempmm=!bat_tempfilename:~10,2!
		set bat_tempdd=!bat_tempfilename:~12,2!
		set bat_temphh=!bat_tempfilename:~15,2!
		set bat_tempmin=!bat_tempfilename:~17,2!
		set bat_tempsec=!bat_tempfilename:~19,2!
		
		set bat_tempspec=!bat_temphh!!bat_tempmin!!bat_tempsec!
		
		title working on Cal file: "!bat_fffilename!" %%f
		
		if !bat_found! equ 0 (
			if !bat_tempspec! lss !bat_filespec! (
				set bat_found=!bat_tempfilefull!
				set bat_calffname=!bat_tempfilefull!
				echo                                      FOUND "!bat_found!"
				echo     copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
				         copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
			) else (
				rem echo NOT FOUND
				rem set bat_
				rem pause
			)
		)
	)

	echo :COPYCALFF-return Cal File FF name for "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"  ["!bat_calffname"]
%return%

:GETCAMERAFROMDETECT
	echo :GETCAMERAFROMDETECT [%*]
	
	rem Try FTPdetectinfoC.txt
	if exist "%~1\FTPdetectinfoC.txt" (
		set bat_detectfile1=%~1\FTPdetectinfoC.txt 
		echo bat_detectfile1=!bat_detectfile1!
	) else (
		if exist "%~1\FTPdetectinfo_????_????_??_??.txt" (
			rem Try FTPdetectinfo_###_yyyy_mm_dd.txt
			echo if exist "%~1\FTPdetectinfo_????_????_??_??.txt"
			for /f "usebackq tokens=*" %%b in (`dir "%~1\FTPdetectinfo_???_????_??_??.txt" /a-d /s/b`) do (
				set bat_detectfile1=%%~dpnxb
			)
		) else (
			set bat_detectfile1=%~1\FTPdetectinfo.txt
			echo bat_detectfile1=!bat_detectfile1!
		)
	)
	
	for /f "usebackq skip=2 tokens=*" %%b in (`find /i ".bin" "!bat_detectfile1!"`) do (
		set bat_camera=%%b
		set bat_camera=!bat_camera:~2,3!
	)
	
	if "!bat_camera!" equ "" (
		for /f "usebackq tokens=*" %%b in (`find /i "is the reference" "%~1\FFCorruptFilesLog_Case*.txt"`) do (
pause
		   set bat_camera=%%b
		   set bat_camera=!bat_camera:~2,3!
echo camera=!bat_camera!
		)
	)

	echo :GETCAMERAFROMDETECT-return [%*]   [camera=!bat_camera!] [!bat_detectfile1!]
	if "!bat_camera!" equ "" (
		echo     ERROR: couldn't determine camera number
		set /p bat_camera=ENTER THE CAMERA NUMBER: 
	)
%return%


:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0
	echo.
	echo Displays the CAMS menu system to facilitate access to batch scripts
	echo and processing
	echo.
	echo.
exit /b 9

Needs:
	- call launchcapture (asynch)
	- call ftp_capture (asynch)
	- merge all captures for a single date
	- merge all archived for a single date (harder to do)
	- call makecaselisting (asynch)
	- call Merge cases
	- call ftp_meteorcal
	- call ftp_meteorcal_update
	- call Apply, then merge
	- skippedFrames monitoring
	- Add pick list function to choose date
	- convert all batch scripts to be able to run at the same time
	


:DONE
	call :SAVECONFIG
	echo.
	echo Done with %0 %*
	echo.
