
@echo off

:SETUP
	setlocal enableextensions enabledelayedexpansion
		set /a bat_totalconfirmed=0

:MAIN

	cls
	echo Archived  Confirmed  Archived     Confirmed     Ratio  Comments
	echo ------    ------     ----------   ----------    -----  ------------------------

	if not exist "archivedfiles" goto :ERR1
	if not exist "confirmedfiles" goto :ERR2

	rem Loop through all the ".\Submitted\FTPdetectinfo.txt" files
	for /f "usebackq tokens=*" %%a in (`dir "Submitted\ftpdetectinfo_scanned.txt" /s/b /a-d^|sort /r`) do (

		set bat_msg= 
		rem Loop to extract the Meteor Count = value
		for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i /n "Meteor Count" "%%a"`) do (
			set bat_temp=%%d
			set bat_count1=!bat_temp:~-6!
			if "!bat_count1!" equ "000000" (
				set bat_msg=; needs FTP_Reprocess
			)
		)

		set bat_temp=%%a

		set bat_filename=%%~nxa

		set bat_path=%%~dpa&			rem get the path ("x:\cams\Submitted\[date/time]\EmailFiles
		set bat_emaildir=!bat_path!::
		set bat_emaildir=!bat_emaildir:\::=!
		set bat_emaildir=!bat_emaildir:::=!

		set bat_pathlefta=!bat_path:\EmailFiles\=!&rem remove the "\EmailFiles\", including trailing backslashes
		set bat_cameradir=!bat_pathlefta!
		
		for /f "tokens=*" %%b in ("!bat_cameradir!") do (
			set bat_pathdate=%%~dpb::
			set bat_pathdate=!bat_pathdate:\::=!
			set bat_pathdate=!bat_pathdate:::=!
			set bat_camera=%%~nxb
		)

		set bat_dirname=!bat_pathdate!&	rem Extract just the directory name (e.g. "2011_08_22_05_17_09")
		for /f "tokens=*" %%b in ("!bat_dirname!") do (
			set bat_pathdate=%%~dpb::
			set bat_pathdate=!bat_pathdate:\::=!
			set bat_pathdate=!bat_pathdate:::=!
			set bat_dirname=%%~nxb
		)


		set bat_found=0&	rem Use this to determine if matching dir is found in ConfirmedFiles or not

 rem echo temp		!bat_temp! 
 rem echo path=		!bat_path!
 rem echo emaildir	!bat_emaildir!
 rem echo pathlefta=	!bat_pathlefta!
 rem echo camera		!bat_cameradir!
 rem echo pathdate	!bat_pathdate!
 rem echo dirname=	!bat_dirname!
 rem echo filename=	!bat_filename!
 rem echo count=		!bat_count1!
 rem echo camera=		!bat_camera!	

		rem Loop to list all the FTPdetectinfo.txt files in the ConfirmedFiles directory. 
		rem Inside the loop, it will search for the bat_dirname in the resulting list.
		if not exist "!bat_emaildir!\FTPdetectinfo_confirmed.txt" (
			set bat_dirname2=                   
			set bat_msg=!bat_msg!; not confirmed
			set bat_count2=000000

			rem Loops to remove leading zeros
			for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
			for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)
	
			if not defined bat_count1nz set bat_count1nz=0
			if not defined bat_count2nz set bat_count2nz=0
	
			rem logic to avoid divide by zero
			if "!bat_count2!" neq "000000" (
				rem set bat_count
				rem echo set /a bat_ratio=!bat_count1nz!/!!bat_count2nz!
				set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
			) else (
				set /a bat_ratio=0
			)
			
		) else (
			for /f "usebackq tokens=*" %%b in (`dir "!bat_emaildir!\FTPdetectinfo_confirmed.txt" /s/b`) do (
				rem To speed things up, skip if already found.
				if "!bat_found!" equ "0" (
					set bat_temp=%%b
					set bat_file2=%%~nxb
					set bat_path2=%%~dpb!::&	rem Extract everything but the filename ("\FTPdetectinfo.txt")
					set bat_path2=!bat_path2:\::=!
					set bat_path2=!bat_path2:::=!
					
					set bat_dirname2=!bat_dirname!

rem echo dirname2	!bat_dirname2!


					if "!bat_dirname!" equ "!bat_dirname2!" (
						set bat_found=1
						for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i /n "meteor count" "%%b"`) do (
							set bat_temp=%%d
							set bat_count2=!bat_temp:~-6!
						)

:STRIPZEROS
						rem Loops to remove leading zeros
						for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
						for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)

						if not defined bat_count1nz set bat_count1nz=0
						if not defined bat_count2nz set bat_count2nz=0

						rem logic to avoid divide by zero
						if "!bat_count2!" neq "000000" (
							rem set bat_count
							rem echo set /a bat_ratio=!bat_count1nz!/!bat_count2nz!
							set /a bat_ratio=!bat_count1nz!^/!bat_count2nz!
							set /a bat_totalconfirmed+=!bat_count2nz!
							rem echo !bat_totalconfirmed!
						) else (
							set /a bat_ratio=0
						)
						
						set bat_ratio=   !bat_ratio!
						set bat_ratio=!bat_ratio:~-3!

						rem echo !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!
						set bat_output=!bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!

						set bat_comments=!bat_emaildir!\comments.txt
						set bat_commentspace=                                                         
	
						rem append the text in comments.txt to bat_msg
						if exist "!bat_comments!" (
							for /f "usebackq tokens=*" %%f in (`type "!bat_comments!"`) do (
								rem set bat_msg=; %%f
rem echo aaaaaaaaaaa !bat_output!
								if "!bat_msg!" equ " " (
									set bat_msg=; %%f
									set bat_output=!bat_output!!bat_msg!
									echo !bat_output!
								) else (
									if "!bat_msg!" equ "; needs FTP_Reprocess" (
										set bat_msg=; %%f
						set bat_output=!bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!
										echo !bat_output!
										rem echo !bat_commentspace!%%f
									) else (
										rem echo !bat_output!
										echo !bat_commentspace!%%f
									)
								)
							)
							rem echo.
						) else (
							echo !bat_output!
							set bat_comments=
						)

					)
				)
			)&	rem end for /f ... %%b
		)
		
		
		set bat_comments=!bat_path2!\EmailFiles\comments.txt

		rem append the text in comments.txt to bat_msg
		if exist "!bat_comments!" (
			for /f "usebackq tokens=*" %%f in (`type "!bat_comments!"`) do (
				set bat_msg=!bat_msg!; %%f
			)
		)
		
		rem echo !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!

		if "!bat_found!" equ 0 (
			echo "%%a" not yet confirmed.
		) else (
			rem
		)
	)&	rem end for /f ... %%a
	echo Total Confirmed=!bat_totalconfirmed!
exit /b 0

:ERR1
	echo The directory, "%cd%\ArchivedFiles", does not exist. 
	exit /b 1

:ERR2
	echo The directory, "%cd%\ConfirmedFiles", does not exist. 
	exit /b 2
